// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// UnsubscribeCalendarACL 该接口用于以用户身份取消订阅指定日历下的日历成员变更事件。
//
// 用户必须对日历有访问权限。
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/calendar-v4/calendar-acl/unsubscription
func (r *CalendarService) UnsubscribeCalendarACL(ctx context.Context, request *UnsubscribeCalendarACLReq, options ...MethodOptionFunc) (*UnsubscribeCalendarACLResp, *Response, error) {
	if r.cli.mock.mockCalendarUnsubscribeCalendarACL != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] Calendar#UnsubscribeCalendarACL mock enable")
		return r.cli.mock.mockCalendarUnsubscribeCalendarACL(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:               "Calendar",
		API:                 "UnsubscribeCalendarACL",
		Method:              "POST",
		URL:                 r.cli.openBaseURL + "/open-apis/calendar/v4/calendars/:calendar_id/acls/unsubscription",
		Body:                request,
		MethodOption:        newMethodOption(options),
		NeedUserAccessToken: true,
	}
	resp := new(unsubscribeCalendarACLResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockCalendarUnsubscribeCalendarACL mock CalendarUnsubscribeCalendarACL method
func (r *Mock) MockCalendarUnsubscribeCalendarACL(f func(ctx context.Context, request *UnsubscribeCalendarACLReq, options ...MethodOptionFunc) (*UnsubscribeCalendarACLResp, *Response, error)) {
	r.mockCalendarUnsubscribeCalendarACL = f
}

// UnMockCalendarUnsubscribeCalendarACL un-mock CalendarUnsubscribeCalendarACL method
func (r *Mock) UnMockCalendarUnsubscribeCalendarACL() {
	r.mockCalendarUnsubscribeCalendarACL = nil
}

// UnsubscribeCalendarACLReq ...
type UnsubscribeCalendarACLReq struct {
	CalendarID string `path:"calendar_id" json:"-"` // 日历ID。参见[日历ID说明](https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/calendar-v4/calendar/introduction), 示例值: "feishu.cn_xxxxxxxxxx@group.calendar.feishu.cn"
}

// UnsubscribeCalendarACLResp ...
type UnsubscribeCalendarACLResp struct {
}

// unsubscribeCalendarACLResp ...
type unsubscribeCalendarACLResp struct {
	Code int64                       `json:"code,omitempty"` // 错误码, 非 0 表示失败
	Msg  string                      `json:"msg,omitempty"`  // 错误描述
	Data *UnsubscribeCalendarACLResp `json:"data,omitempty"`
}
