// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// DeleteDriveComment 删除云文档中的某条回复。
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/drive-v1/file-comment-reply/delete
func (r *DriveService) DeleteDriveComment(ctx context.Context, request *DeleteDriveCommentReq, options ...MethodOptionFunc) (*DeleteDriveCommentResp, *Response, error) {
	if r.cli.mock.mockDriveDeleteDriveComment != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] Drive#DeleteDriveComment mock enable")
		return r.cli.mock.mockDriveDeleteDriveComment(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:                 "Drive",
		API:                   "DeleteDriveComment",
		Method:                "DELETE",
		URL:                   r.cli.openBaseURL + "/open-apis/drive/v1/files/:file_token/comments/:comment_id/replies/:reply_id",
		Body:                  request,
		MethodOption:          newMethodOption(options),
		NeedTenantAccessToken: true,
		NeedUserAccessToken:   true,
	}
	resp := new(deleteDriveCommentResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockDriveDeleteDriveComment mock DriveDeleteDriveComment method
func (r *Mock) MockDriveDeleteDriveComment(f func(ctx context.Context, request *DeleteDriveCommentReq, options ...MethodOptionFunc) (*DeleteDriveCommentResp, *Response, error)) {
	r.mockDriveDeleteDriveComment = f
}

// UnMockDriveDeleteDriveComment un-mock DriveDeleteDriveComment method
func (r *Mock) UnMockDriveDeleteDriveComment() {
	r.mockDriveDeleteDriveComment = nil
}

// DeleteDriveCommentReq ...
type DeleteDriveCommentReq struct {
	FileToken string   `path:"file_token" json:"-"` // 文档token, 示例值: "doccnHh7U87HOFpii5u5G*"
	CommentID string   `path:"comment_id" json:"-"` // 评论ID, 示例值: "6916106822734578184"
	ReplyID   string   `path:"reply_id" json:"-"`   // 回复ID, 示例值: "6916106822734594568"
	FileType  FileType `query:"file_type" json:"-"` // 文档类型, 示例值: "doc", 可选值有: doc: 文档, sheet: 表格, file: 文件, docx: 新版文档
}

// DeleteDriveCommentResp ...
type DeleteDriveCommentResp struct {
}

// deleteDriveCommentResp ...
type deleteDriveCommentResp struct {
	Code int64                   `json:"code,omitempty"` // 错误码, 非 0 表示失败
	Msg  string                  `json:"msg,omitempty"`  // 错误描述
	Data *DeleteDriveCommentResp `json:"data,omitempty"`
}
