// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// EventV2ACSUserUpdatedV1 智能门禁用户特征值变化时, 发送此事件{使用示例}(url=/api/tools/api_explore/api_explore_config?project=acs&version=v1&resource=user&event=updated)
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/acs-v1/user/events/updated
func (r *EventCallbackService) HandlerEventV2ACSUserUpdatedV1(f EventV2ACSUserUpdatedV1Handler) {
	r.cli.eventHandler.eventV2ACSUserUpdatedV1Handler = f
}

// EventV2ACSUserUpdatedV1Handler event EventV2ACSUserUpdatedV1 handler
type EventV2ACSUserUpdatedV1Handler func(ctx context.Context, cli *Lark, schema string, header *EventHeaderV2, event *EventV2ACSUserUpdatedV1) (string, error)

// EventV2ACSUserUpdatedV1 ...
type EventV2ACSUserUpdatedV1 struct {
	UserID       *EventV2ACSUserUpdatedV1UserID `json:"user_id,omitempty"`       // 用户 ID
	Card         int64                          `json:"card,omitempty"`          // 卡号
	FaceUploaded bool                           `json:"face_uploaded,omitempty"` // 是否上传人脸图片
}

// EventV2ACSUserUpdatedV1UserID ...
type EventV2ACSUserUpdatedV1UserID struct {
	UnionID string `json:"union_id,omitempty"` // 用户的 union id
	UserID  string `json:"user_id,omitempty"`  // 用户的 user id, 字段权限要求: 获取用户 user ID
	OpenID  string `json:"open_id,omitempty"`  // 用户的 open id
}
