// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// EventV2ApplicationApplicationAppVersionPublishApplyV6 通过订阅该事件, 可接收应用提交发布申请事件{使用示例}(url=/api/tools/api_explore/api_explore_config?project=application&version=v6&resource=application.app_version&event=publish_apply)
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/application-v6/application-app_version/events/publish_apply
func (r *EventCallbackService) HandlerEventV2ApplicationApplicationAppVersionPublishApplyV6(f EventV2ApplicationApplicationAppVersionPublishApplyV6Handler) {
	r.cli.eventHandler.eventV2ApplicationApplicationAppVersionPublishApplyV6Handler = f
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6Handler event EventV2ApplicationApplicationAppVersionPublishApplyV6 handler
type EventV2ApplicationApplicationAppVersionPublishApplyV6Handler func(ctx context.Context, cli *Lark, schema string, header *EventHeaderV2, event *EventV2ApplicationApplicationAppVersionPublishApplyV6) (string, error)

// EventV2ApplicationApplicationAppVersionPublishApplyV6 ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6 struct {
	OperatorID        *EventV2ApplicationApplicationAppVersionPublishApplyV6OperatorID        `json:"operator_id,omitempty"`         // 用户 ID
	OnlineVersion     *EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersion     `json:"online_version,omitempty"`      // 当前线上版本信息
	UnderAuditVersion *EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersion `json:"under_audit_version,omitempty"` // 当前线上版本信息
	AppStatus         int64                                                                   `json:"app_status,omitempty"`          // 应用状态, 可选值有: 0: 停用状态, 1: 启用状态
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersion ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersion struct {
	AppID            string                                                                     `json:"app_id,omitempty"`            // 应用 id
	Version          string                                                                     `json:"version,omitempty"`           // 开发者填入的应用版本 ID, 最小长度: `1` 字符
	VersionID        string                                                                     `json:"version_id,omitempty"`        // 唯一标识应用版本的 ID
	AppName          string                                                                     `json:"app_name,omitempty"`          // 应用默认名称, 最小长度: `1` 字符
	AvatarURL        string                                                                     `json:"avatar_url,omitempty"`        // 应用头像 url
	Description      string                                                                     `json:"description,omitempty"`       // 应用默认描述, 最小长度: `1` 字符
	Scopes           []*EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionScope `json:"scopes,omitempty"`            // 应用权限列表
	BackHomeURL      string                                                                     `json:"back_home_url,omitempty"`     // 后台主页地址
	I18n             []*EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionI18n  `json:"i18n,omitempty"`              // 应用的国际化信息列表, 最小长度: `1`
	CommonCategories []string                                                                   `json:"common_categories,omitempty"` // 应用分类的国际化描述, 最大长度: `3`
	Events           []string                                                                   `json:"events,omitempty"`            // 应用已订阅开放平台事件列表
	Status           int64                                                                      `json:"status,omitempty"`            // 版本状态, 可选值有: 0: 未知状态, 1: 审核通过, 2: 审核拒绝, 3: 审核中, 4: 未提交审核
	CreateTime       string                                                                     `json:"create_time,omitempty"`       // 版本创建时间（单位: s）
	PublishTime      string                                                                     `json:"publish_time,omitempty"`      // 版本发布时间（单位: s）
	Ability          *EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbility `json:"ability,omitempty"`           // 当前版本下应用开启的能力
	Remark           *EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionRemark  `json:"remark,omitempty"`            // 跟随应用版本的信息
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbility ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbility struct {
	Gadget           *EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityGadget            `json:"gadget,omitempty"`            // 小程序能力
	WebApp           *EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityWebApp            `json:"web_app,omitempty"`           // 网页能力
	Bot              *EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityBot               `json:"bot,omitempty"`               // 机器人能力
	WorkplaceWidgets []*EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityWorkplaceWidget `json:"workplace_widgets,omitempty"` // 小组件能力
	Navigate         *EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityNavigate          `json:"navigate,omitempty"`          // 主导航小程序
	CloudDoc         *EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityCloudDoc          `json:"cloud_doc,omitempty"`         // 云文档应用
	DocsBlocks       []*EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityDocsBlock       `json:"docs_blocks,omitempty"`       // 云文档小组件
	MessageAction    *EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityMessageAction     `json:"message_action,omitempty"`    // 消息快捷操作
	PlusMenu         *EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityPlusMenu          `json:"plus_menu,omitempty"`         // 加号菜单
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityBot ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityBot struct {
	CardRequestURL string `json:"card_request_url,omitempty"` // 消息卡片回调地址
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityCloudDoc ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityCloudDoc struct {
	SpaceURL string                                                                                   `json:"space_url,omitempty"` // 云空间重定向 url
	I18n     []*EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityCloudDocI18n `json:"i18n,omitempty"`      // 国际化信息, 最小长度: `1`
	IconURL  string                                                                                   `json:"icon_url,omitempty"`  // 图标链接
	Mode     int64                                                                                    `json:"mode,omitempty"`      // 云文档支持模式, 可选值有: 0: 未知, 1: 移动端
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityCloudDocI18n ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityCloudDocI18n struct {
	I18nKey          string `json:"i18n_key,omitempty"`          // 国际化语言的 key, 可选值有: zh_cn: 中文, en_us: 英文, ja_jp: 日文
	Name             string `json:"name,omitempty"`              // 云文档国际化名称
	ReadDescription  string `json:"read_description,omitempty"`  // 云文档国际化读权限说明
	WriteDescription string `json:"write_description,omitempty"` // 云文档国际化写权限说明
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityDocsBlock ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityDocsBlock struct {
	BlockTypeID   string                                                                                    `json:"block_type_id,omitempty"`   // BlockTypeID
	I18n          []*EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityDocsBlockI18n `json:"i18n,omitempty"`            // block 的国际化信息, 最小长度: `1`
	MobileIconURL string                                                                                    `json:"mobile_icon_url,omitempty"` // 移动端 icon 链接
	PcIconURL     string                                                                                    `json:"pc_icon_url,omitempty"`     // pc 端口 icon 链接
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityDocsBlockI18n ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityDocsBlockI18n struct {
	I18nKey string `json:"i18n_key,omitempty"` // 国际化语言的 key, 可选值有: zh_cn: 中文, en_us: 英文, ja_jp: 日文
	Name    string `json:"name,omitempty"`     // 名称, 最小长度: `1` 字符
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityGadget ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityGadget struct {
	EnablePcMode         int64    `json:"enable_pc_mode,omitempty"`          // pc 支持的小程序模式, bit 位表示, 可选值有: 1: sidebar 模式, 2: pc 模式, 4: 主导航模式
	SchemaURLs           []string `json:"schema_urls,omitempty"`             // schema url 列表
	PcUseMobilePkg       bool     `json:"pc_use_mobile_pkg,omitempty"`       // pc 端是否使用小程序版本
	PcVersion            string   `json:"pc_version,omitempty"`              // pc 的小程序版本号, 最小长度: `1` 字符
	MobileVersion        string   `json:"mobile_version,omitempty"`          // 移动端小程序版本号, 最小长度: `1` 字符
	MobileMinLarkVersion string   `json:"mobile_min_lark_version,omitempty"` // 移动端兼容的最低飞书版本, 最小长度: `1` 字符
	PcMinLarkVersion     string   `json:"pc_min_lark_version,omitempty"`     // pc 端兼容的最低飞书版本, 最小长度: `1` 字符
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityMessageAction ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityMessageAction struct {
	PcAppLink     string                                                                                        `json:"pc_app_link,omitempty"`     // pc 端链接
	MobileAppLink string                                                                                        `json:"mobile_app_link,omitempty"` // 移动端链接
	I18n          []*EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityMessageActionI18n `json:"i18n,omitempty"`            // 国际化信息, 最小长度: `1`
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityMessageActionI18n ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityMessageActionI18n struct {
	I18nKey string `json:"i18n_key,omitempty"` // 国际化语言的 key, 可选值有: zh_cn: 中文, en_us: 英文, ja_jp: 日文
	Name    string `json:"name,omitempty"`     // 国际化名称, 最小长度: `1` 字符
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityNavigate ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityNavigate struct {
	Pc     *EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityNavigatePc     `json:"pc,omitempty"`     // pc 端主导航信息
	Mobile *EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityNavigateMobile `json:"mobile,omitempty"` // 移动端主导航信息
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityNavigateMobile ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityNavigateMobile struct {
	Version       string `json:"version,omitempty"`         // 主导航小程序版本号, 最小长度: `1` 字符
	ImageURL      string `json:"image_url,omitempty"`       // 默认图片 url
	HoverImageURL string `json:"hover_image_url,omitempty"` // 选中态图片 url
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityNavigatePc ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityNavigatePc struct {
	Version       string `json:"version,omitempty"`         // 主导航小程序版本号, 最小长度: `1` 字符
	ImageURL      string `json:"image_url,omitempty"`       // 默认图片 url
	HoverImageURL string `json:"hover_image_url,omitempty"` // 选中态图片 url
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityPlusMenu ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityPlusMenu struct {
	PcAppLink     string `json:"pc_app_link,omitempty"`     // pc 端链接
	MobileAppLink string `json:"mobile_app_link,omitempty"` // 移动端链接
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityWebApp ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityWebApp struct {
	PcURL     string `json:"pc_url,omitempty"`     // pc 端 url
	MobileURL string `json:"mobile_url,omitempty"` // 移动端 url
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityWorkplaceWidget ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionAbilityWorkplaceWidget struct {
	MinLarkVersion string `json:"min_lark_version,omitempty"` // 最低兼容 lark 版本号
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionI18n ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionI18n struct {
	I18nKey     string `json:"i18n_key,omitempty"`    // 国际化语言的 key, 可选值有: zh_cn: 中文, en_us: 英文, ja_jp: 日文
	Name        string `json:"name,omitempty"`        // 应用国际化名称, 最小长度: `1` 字符
	Description string `json:"description,omitempty"` // 应用国际化描述（副标题）, 最小长度: `1` 字符
	HelpUse     string `json:"help_use,omitempty"`    // 帮助国际化文档链接
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionRemark ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionRemark struct {
	Remark       string                                                                              `json:"remark,omitempty"`        // 备注说明
	UpdateRemark string                                                                              `json:"update_remark,omitempty"` // 更新说明
	Visibility   *EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionRemarkVisibility `json:"visibility,omitempty"`    // 可见性名单
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionRemarkVisibility ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionRemarkVisibility struct {
	IsAll         bool                                                                                             `json:"is_all,omitempty"`         // 是否全员可见
	VisibleList   *EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionRemarkVisibilityVisibleList   `json:"visible_list,omitempty"`   // 可见名单
	InvisibleList *EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionRemarkVisibilityInvisibleList `json:"invisible_list,omitempty"` // 不可见名单
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionRemarkVisibilityInvisibleList ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionRemarkVisibilityInvisibleList struct {
	OpenIDs       []string `json:"open_ids,omitempty"`       // 可见性成员 id 列表
	DepartmentIDs []string `json:"department_ids,omitempty"` // 可见性部门的 id 列表
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionRemarkVisibilityVisibleList ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionRemarkVisibilityVisibleList struct {
	OpenIDs       []string `json:"open_ids,omitempty"`       // 可见性成员 id 列表
	DepartmentIDs []string `json:"department_ids,omitempty"` // 可见性部门的 id 列表
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionScope ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OnlineVersionScope struct {
	Scope       string `json:"scope,omitempty"`       // 应用权限
	Description string `json:"description,omitempty"` // 应用权限的国际化描述
	Level       int64  `json:"level,omitempty"`       // 权限等级描述, 可选值有: 1: 普通权限, 2: 高级权限, 3: 超敏感权限, 0: 未知等级
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6OperatorID ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6OperatorID struct {
	UnionID string `json:"union_id,omitempty"` // 用户的 union id
	UserID  string `json:"user_id,omitempty"`  // 用户的 user id, 字段权限要求: 获取用户 user ID
	OpenID  string `json:"open_id,omitempty"`  // 用户的 open id
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersion ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersion struct {
	AppID            string                                                                         `json:"app_id,omitempty"`            // 应用 id
	Version          string                                                                         `json:"version,omitempty"`           // 开发者填入的应用版本 ID, 最小长度: `1` 字符
	VersionID        string                                                                         `json:"version_id,omitempty"`        // 唯一标识应用版本的 ID
	AppName          string                                                                         `json:"app_name,omitempty"`          // 应用默认名称, 最小长度: `1` 字符
	AvatarURL        string                                                                         `json:"avatar_url,omitempty"`        // 应用头像 url
	Description      string                                                                         `json:"description,omitempty"`       // 应用默认描述, 最小长度: `1` 字符
	Scopes           []*EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionScope `json:"scopes,omitempty"`            // 应用权限列表
	BackHomeURL      string                                                                         `json:"back_home_url,omitempty"`     // 后台主页地址
	I18n             []*EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionI18n  `json:"i18n,omitempty"`              // 应用的国际化信息列表, 最小长度: `1`
	CommonCategories []string                                                                       `json:"common_categories,omitempty"` // 应用分类的国际化描述, 最大长度: `3`
	Events           []string                                                                       `json:"events,omitempty"`            // 应用已订阅开放平台事件列表
	Status           int64                                                                          `json:"status,omitempty"`            // 版本状态, 可选值有: 0: 未知状态, 1: 审核通过, 2: 审核拒绝, 3: 审核中, 4: 未提交审核
	CreateTime       string                                                                         `json:"create_time,omitempty"`       // 版本创建时间（单位: s）
	PublishTime      string                                                                         `json:"publish_time,omitempty"`      // 版本发布时间（单位: s）
	Ability          *EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbility `json:"ability,omitempty"`           // 当前版本下应用开启的能力
	Remark           *EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionRemark  `json:"remark,omitempty"`            // 跟随应用版本的信息
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbility ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbility struct {
	Gadget           *EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityGadget            `json:"gadget,omitempty"`            // 小程序能力
	WebApp           *EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityWebApp            `json:"web_app,omitempty"`           // 网页能力
	Bot              *EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityBot               `json:"bot,omitempty"`               // 机器人能力
	WorkplaceWidgets []*EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityWorkplaceWidget `json:"workplace_widgets,omitempty"` // 小组件能力
	Navigate         *EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityNavigate          `json:"navigate,omitempty"`          // 主导航小程序
	CloudDoc         *EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityCloudDoc          `json:"cloud_doc,omitempty"`         // 云文档应用
	DocsBlocks       []*EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityDocsBlock       `json:"docs_blocks,omitempty"`       // 云文档小组件
	MessageAction    *EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityMessageAction     `json:"message_action,omitempty"`    // 消息快捷操作
	PlusMenu         *EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityPlusMenu          `json:"plus_menu,omitempty"`         // 加号菜单
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityBot ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityBot struct {
	CardRequestURL string `json:"card_request_url,omitempty"` // 消息卡片回调地址
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityCloudDoc ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityCloudDoc struct {
	SpaceURL string                                                                                       `json:"space_url,omitempty"` // 云空间重定向 url
	I18n     []*EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityCloudDocI18n `json:"i18n,omitempty"`      // 国际化信息, 最小长度: `1`
	IconURL  string                                                                                       `json:"icon_url,omitempty"`  // 图标链接
	Mode     int64                                                                                        `json:"mode,omitempty"`      // 云文档支持模式, 可选值有: 0: 未知, 1: 移动端
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityCloudDocI18n ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityCloudDocI18n struct {
	I18nKey          string `json:"i18n_key,omitempty"`          // 国际化语言的 key, 可选值有: zh_cn: 中文, en_us: 英文, ja_jp: 日文
	Name             string `json:"name,omitempty"`              // 云文档国际化名称
	ReadDescription  string `json:"read_description,omitempty"`  // 云文档国际化读权限说明
	WriteDescription string `json:"write_description,omitempty"` // 云文档国际化写权限说明
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityDocsBlock ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityDocsBlock struct {
	BlockTypeID   string                                                                                        `json:"block_type_id,omitempty"`   // BlockTypeID
	I18n          []*EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityDocsBlockI18n `json:"i18n,omitempty"`            // block 的国际化信息, 最小长度: `1`
	MobileIconURL string                                                                                        `json:"mobile_icon_url,omitempty"` // 移动端 icon 链接
	PcIconURL     string                                                                                        `json:"pc_icon_url,omitempty"`     // pc 端口 icon 链接
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityDocsBlockI18n ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityDocsBlockI18n struct {
	I18nKey string `json:"i18n_key,omitempty"` // 国际化语言的 key, 可选值有: zh_cn: 中文, en_us: 英文, ja_jp: 日文
	Name    string `json:"name,omitempty"`     // 名称, 最小长度: `1` 字符
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityGadget ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityGadget struct {
	EnablePcMode         int64    `json:"enable_pc_mode,omitempty"`          // pc 支持的小程序模式, bit 位表示, 可选值有: 1: sidebar 模式, 2: pc 模式, 4: 主导航模式
	SchemaURLs           []string `json:"schema_urls,omitempty"`             // schema url 列表
	PcUseMobilePkg       bool     `json:"pc_use_mobile_pkg,omitempty"`       // pc 端是否使用小程序版本
	PcVersion            string   `json:"pc_version,omitempty"`              // pc 的小程序版本号, 最小长度: `1` 字符
	MobileVersion        string   `json:"mobile_version,omitempty"`          // 移动端小程序版本号, 最小长度: `1` 字符
	MobileMinLarkVersion string   `json:"mobile_min_lark_version,omitempty"` // 移动端兼容的最低飞书版本, 最小长度: `1` 字符
	PcMinLarkVersion     string   `json:"pc_min_lark_version,omitempty"`     // pc 端兼容的最低飞书版本, 最小长度: `1` 字符
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityMessageAction ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityMessageAction struct {
	PcAppLink     string                                                                                            `json:"pc_app_link,omitempty"`     // pc 端链接
	MobileAppLink string                                                                                            `json:"mobile_app_link,omitempty"` // 移动端链接
	I18n          []*EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityMessageActionI18n `json:"i18n,omitempty"`            // 国际化信息, 最小长度: `1`
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityMessageActionI18n ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityMessageActionI18n struct {
	I18nKey string `json:"i18n_key,omitempty"` // 国际化语言的 key, 可选值有: zh_cn: 中文, en_us: 英文, ja_jp: 日文
	Name    string `json:"name,omitempty"`     // 国际化名称, 最小长度: `1` 字符
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityNavigate ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityNavigate struct {
	Pc     *EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityNavigatePc     `json:"pc,omitempty"`     // pc 端主导航信息
	Mobile *EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityNavigateMobile `json:"mobile,omitempty"` // 移动端主导航信息
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityNavigateMobile ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityNavigateMobile struct {
	Version       string `json:"version,omitempty"`         // 主导航小程序版本号, 最小长度: `1` 字符
	ImageURL      string `json:"image_url,omitempty"`       // 默认图片 url
	HoverImageURL string `json:"hover_image_url,omitempty"` // 选中态图片 url
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityNavigatePc ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityNavigatePc struct {
	Version       string `json:"version,omitempty"`         // 主导航小程序版本号, 最小长度: `1` 字符
	ImageURL      string `json:"image_url,omitempty"`       // 默认图片 url
	HoverImageURL string `json:"hover_image_url,omitempty"` // 选中态图片 url
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityPlusMenu ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityPlusMenu struct {
	PcAppLink     string `json:"pc_app_link,omitempty"`     // pc 端链接
	MobileAppLink string `json:"mobile_app_link,omitempty"` // 移动端链接
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityWebApp ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityWebApp struct {
	PcURL     string `json:"pc_url,omitempty"`     // pc 端 url
	MobileURL string `json:"mobile_url,omitempty"` // 移动端 url
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityWorkplaceWidget ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionAbilityWorkplaceWidget struct {
	MinLarkVersion string `json:"min_lark_version,omitempty"` // 最低兼容 lark 版本号
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionI18n ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionI18n struct {
	I18nKey     string `json:"i18n_key,omitempty"`    // 国际化语言的 key, 可选值有: zh_cn: 中文, en_us: 英文, ja_jp: 日文
	Name        string `json:"name,omitempty"`        // 应用国际化名称, 最小长度: `1` 字符
	Description string `json:"description,omitempty"` // 应用国际化描述（副标题）, 最小长度: `1` 字符
	HelpUse     string `json:"help_use,omitempty"`    // 帮助国际化文档链接
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionRemark ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionRemark struct {
	Remark       string                                                                                  `json:"remark,omitempty"`        // 备注说明
	UpdateRemark string                                                                                  `json:"update_remark,omitempty"` // 更新说明
	Visibility   *EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionRemarkVisibility `json:"visibility,omitempty"`    // 可见性名单
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionRemarkVisibility ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionRemarkVisibility struct {
	IsAll         bool                                                                                                 `json:"is_all,omitempty"`         // 是否全员可见
	VisibleList   *EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionRemarkVisibilityVisibleList   `json:"visible_list,omitempty"`   // 可见名单
	InvisibleList *EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionRemarkVisibilityInvisibleList `json:"invisible_list,omitempty"` // 不可见名单
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionRemarkVisibilityInvisibleList ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionRemarkVisibilityInvisibleList struct {
	OpenIDs       []string `json:"open_ids,omitempty"`       // 可见性成员 id 列表
	DepartmentIDs []string `json:"department_ids,omitempty"` // 可见性部门的 id 列表
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionRemarkVisibilityVisibleList ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionRemarkVisibilityVisibleList struct {
	OpenIDs       []string `json:"open_ids,omitempty"`       // 可见性成员 id 列表
	DepartmentIDs []string `json:"department_ids,omitempty"` // 可见性部门的 id 列表
}

// EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionScope ...
type EventV2ApplicationApplicationAppVersionPublishApplyV6UnderAuditVersionScope struct {
	Scope       string `json:"scope,omitempty"`       // 应用权限
	Description string `json:"description,omitempty"` // 应用权限的国际化描述
	Level       int64  `json:"level,omitempty"`       // 权限等级描述, 可选值有: 1: 普通权限, 2: 高级权限, 3: 超敏感权限, 0: 未知等级
}
