// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// EventV2ContactDepartmentDeletedV3 订阅这一事件可以获得被删除部门的信息。{使用示例}(url=/api/tools/api_explore/api_explore_config?project=contact&version=v3&resource=department&event=deleted)
//
// 只有当应用拥有被改动字段的数据权限时, 才会接收到事件。具体的数据权限与字段的关系请参考[应用权限](https://open.feishu.cn/document/ukTMukTMukTM/uQjN3QjL0YzN04CN2cDN), 或查看事件体参数列表的字段描述。
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/contact-v3/department/events/deleted
func (r *EventCallbackService) HandlerEventV2ContactDepartmentDeletedV3(f EventV2ContactDepartmentDeletedV3Handler) {
	r.cli.eventHandler.eventV2ContactDepartmentDeletedV3Handler = f
}

// EventV2ContactDepartmentDeletedV3Handler event EventV2ContactDepartmentDeletedV3 handler
type EventV2ContactDepartmentDeletedV3Handler func(ctx context.Context, cli *Lark, schema string, header *EventHeaderV2, event *EventV2ContactDepartmentDeletedV3) (string, error)

// EventV2ContactDepartmentDeletedV3 ...
type EventV2ContactDepartmentDeletedV3 struct {
	Object    *EventV2ContactDepartmentDeletedV3Object    `json:"object,omitempty"`     // 部门信息
	OldObject *EventV2ContactDepartmentDeletedV3OldObject `json:"old_object,omitempty"` // 部门被删除前的信息
}

// EventV2ContactDepartmentDeletedV3Object ...
type EventV2ContactDepartmentDeletedV3Object struct {
	Name               string                                           `json:"name,omitempty"`                 // 部门名称, 最小长度: `1` 字符, 字段权限要求（满足任一）: 以应用身份读取通讯录, 获取部门基础信息, 以应用身份访问通讯录, 读取通讯录
	ParentDepartmentID string                                           `json:"parent_department_id,omitempty"` // 父部门的部门open_department_id [部门相关ID概念](https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/contact-v3/department/field-overview#23857fe0), 字段权限要求（满足任一）: 以应用身份读取通讯录, 获取部门组织架构信息, 以应用身份访问通讯录, 读取通讯录
	DepartmentID       string                                           `json:"department_id,omitempty"`        // 本部门的department_id [部门相关ID概念](https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/contact-v3/department/field-overview#23857fe0), 字段权限要求（满足任一）: 以应用身份读取通讯录, 获取部门基础信息, 以应用身份访问通讯录, 读取通讯录
	OpenDepartmentID   string                                           `json:"open_department_id,omitempty"`   // 部门的open_department_id [部门相关ID概念](https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/contact-v3/department/field-overview#23857fe0)
	LeaderUserID       string                                           `json:"leader_user_id,omitempty"`       // 部门主管用户open_id [用户相关的 ID 概念](https://open.feishu.cn/document/home/user-identity-introduction/introduction), 字段权限要求（满足任一）: 以应用身份读取通讯录, 获取部门基础信息, 以应用身份访问通讯录, 读取通讯录
	ChatID             string                                           `json:"chat_id,omitempty"`              // 部门群ID, 字段权限要求（满足任一）: 以应用身份读取通讯录, 获取部门组织架构信息, 以应用身份访问通讯录, 读取通讯录
	Order              int64                                            `json:"order,omitempty"`                // 部门的排序, 字段权限要求（满足任一）: 以应用身份读取通讯录, 获取部门组织架构信息, 以应用身份访问通讯录, 读取通讯录
	Status             *EventV2ContactDepartmentDeletedV3ObjectStatus   `json:"status,omitempty"`               // 部门状态, 字段权限要求（满足任一）: 以应用身份读取通讯录, 获取部门基础信息, 以应用身份访问通讯录, 读取通讯录
	Leaders            []*EventV2ContactDepartmentDeletedV3ObjectLeader `json:"leaders,omitempty"`              // 部门负责人
}

// EventV2ContactDepartmentDeletedV3ObjectLeader ...
type EventV2ContactDepartmentDeletedV3ObjectLeader struct {
	LeaderType int64  `json:"leaderType,omitempty"` // 负责人类型, 可选值有: 1: 主负责人, 2: 副负责人
	LeaderID   string `json:"leaderID,omitempty"`   // 负责人ID, 字段权限要求（满足任一）: 以应用身份读取通讯录, 获取部门组织架构信息, 以应用身份访问通讯录, 读取通讯录
}

// EventV2ContactDepartmentDeletedV3ObjectStatus ...
type EventV2ContactDepartmentDeletedV3ObjectStatus struct {
	IsDeleted bool `json:"is_deleted,omitempty"` // 是否被删除
}

// EventV2ContactDepartmentDeletedV3OldObject ...
type EventV2ContactDepartmentDeletedV3OldObject struct {
	Status           *EventV2ContactDepartmentDeletedV3OldObjectStatus `json:"status,omitempty"`             // 部门状态, 字段权限要求（满足任一）: 以应用身份读取通讯录, 获取部门基础信息, 以应用身份访问通讯录, 读取通讯录
	OpenDepartmentID string                                            `json:"open_department_id,omitempty"` // 部门open_id
}

// EventV2ContactDepartmentDeletedV3OldObjectStatus ...
type EventV2ContactDepartmentDeletedV3OldObjectStatus struct {
	IsDeleted bool `json:"is_deleted,omitempty"` // 是否被删除
}
