// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// EventV2DriveFileEditV1 了解事件订阅的使用场景和配置流程, 请点击查看 [事件订阅概述](https://open.feishu.cn/document/ukTMukTMukTM/uUTNz4SN1MjL1UzM)
//
// 文件编辑将触发此事件。
//
// doc: https://open.feishu.cn/document/ukTMukTMukTM/uUDN04SN0QjL1QDN/event/file-edited
func (r *EventCallbackService) HandlerEventV2DriveFileEditV1(f EventV2DriveFileEditV1Handler) {
	r.cli.eventHandler.eventV2DriveFileEditV1Handler = f
}

// EventV2DriveFileEditV1Handler event EventV2DriveFileEditV1 handler
type EventV2DriveFileEditV1Handler func(ctx context.Context, cli *Lark, schema string, header *EventHeaderV2, event *EventV2DriveFileEditV1) (string, error)

// EventV2DriveFileEditV1 ...
type EventV2DriveFileEditV1 struct {
	FileToken        string                                `json:"file_token,omitempty"`         // 出现编辑的文档token. 如: doccnxxxxxxxxxxxxxxxxxxxxxxx
	FileType         FileType                              `json:"file_type,omitempty"`          // 出现编辑的文档类型. 如: doc
	OperatorIDList   []*EventV2DriveFileEditV1OperatorID   `json:"operator_id_list,omitempty"`   // 编辑人列表
	SubscriberIDList []*EventV2DriveFileEditV1SubscriberID `json:"subscriber_id_list,omitempty"` // 订阅用户列表
}

// EventV2DriveFileEditV1OperatorID ...
type EventV2DriveFileEditV1OperatorID struct {
	OpenID  string `json:"open_id,omitempty"`  // 如: ou_xxxxxxxxxxxxxxxxxxxxxxxxx
	UnionID string `json:"union_id,omitempty"` // 如: on_xxxxxxxxxxxxxxxxxxxxxxxxx
	UserID  string `json:"user_id,omitempty"`  // 如: xxxxxxxx
}

// EventV2DriveFileEditV1SubscriberID ...
type EventV2DriveFileEditV1SubscriberID struct {
	OpenID  string `json:"open_id,omitempty"`  // 如: ou_xxxxxxxxxxxxxxxxxxxxxxxxx
	UnionID string `json:"union_id,omitempty"` // 如: on_xxxxxxxxxxxxxxxxxxxxxxxxx
	UserID  string `json:"user_id,omitempty"`  // 如: xxxxxxxx
}
