// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// EventV2IMChatMemberUserWithdrawnV1 撤销拉用户进群后触发此事件。{使用示例}(url=/api/tools/api_explore/api_explore_config?project=im&version=v1&resource=chat.member.user&event=withdrawn)
//
// 注意事项:
// - 需要开启[机器人能力](https://open.feishu.cn/document/home/develop-a-bot-in-5-minutes/create-an-app)
// - 需要订阅 [消息与群组] 分类下的 [撤销拉用户进群] 事件
// - 事件会向群内订阅了该事件的机器人进行推送
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/chat-member-user/events/withdrawn
func (r *EventCallbackService) HandlerEventV2IMChatMemberUserWithdrawnV1(f EventV2IMChatMemberUserWithdrawnV1Handler) {
	r.cli.eventHandler.eventV2IMChatMemberUserWithdrawnV1Handler = f
}

// EventV2IMChatMemberUserWithdrawnV1Handler event EventV2IMChatMemberUserWithdrawnV1 handler
type EventV2IMChatMemberUserWithdrawnV1Handler func(ctx context.Context, cli *Lark, schema string, header *EventHeaderV2, event *EventV2IMChatMemberUserWithdrawnV1) (string, error)

// EventV2IMChatMemberUserWithdrawnV1 ...
type EventV2IMChatMemberUserWithdrawnV1 struct {
	ChatID            string                                        `json:"chat_id,omitempty"`             // 群组 ID, 详情参见[群ID 说明](https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/im-v1/chat-id-description)
	OperatorID        *EventV2IMChatMemberUserWithdrawnV1OperatorID `json:"operator_id,omitempty"`         // 用户 ID
	External          bool                                          `json:"external,omitempty"`            // 是否是外部群
	OperatorTenantKey string                                        `json:"operator_tenant_key,omitempty"` // 操作者的租户Key, 为租户在飞书上的唯一标识, 用来换取对应的tenant_access_token, 也可以用作租户在应用中的唯一标识
	Users             []*EventV2IMChatMemberUserWithdrawnV1User     `json:"users,omitempty"`               // 被撤销加群的用户列表
}

// EventV2IMChatMemberUserWithdrawnV1OperatorID ...
type EventV2IMChatMemberUserWithdrawnV1OperatorID struct {
	UnionID string `json:"union_id,omitempty"` // 用户的 union id
	UserID  string `json:"user_id,omitempty"`  // 用户的 user id, 字段权限要求: 获取用户 user ID
	OpenID  string `json:"open_id,omitempty"`  // 用户的 open id
}

// EventV2IMChatMemberUserWithdrawnV1User ...
type EventV2IMChatMemberUserWithdrawnV1User struct {
	Name      string                                        `json:"name,omitempty"`       // 用户名字
	TenantKey string                                        `json:"tenant_key,omitempty"` // 租户Key, 为租户在飞书上的唯一标识, 用来换取对应的tenant_access_token, 也可以用作租户在应用中的唯一标识
	UserID    *EventV2IMChatMemberUserWithdrawnV1UserUserID `json:"user_id,omitempty"`    // 用户 ID
}

// EventV2IMChatMemberUserWithdrawnV1UserUserID ...
type EventV2IMChatMemberUserWithdrawnV1UserUserID struct {
	UnionID string `json:"union_id,omitempty"` // 用户的 union id
	UserID  string `json:"user_id,omitempty"`  // 用户的 user id, 字段权限要求: 获取用户 user ID
	OpenID  string `json:"open_id,omitempty"`  // 用户的 open id
}
