// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// UpdateHelpdeskAgentSchedule 该接口用于更新客服的日程
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/helpdesk-v1/agent-schedules/patch
func (r *HelpdeskService) UpdateHelpdeskAgentSchedule(ctx context.Context, request *UpdateHelpdeskAgentScheduleReq, options ...MethodOptionFunc) (*UpdateHelpdeskAgentScheduleResp, *Response, error) {
	if r.cli.mock.mockHelpdeskUpdateHelpdeskAgentSchedule != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] Helpdesk#UpdateHelpdeskAgentSchedule mock enable")
		return r.cli.mock.mockHelpdeskUpdateHelpdeskAgentSchedule(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:               "Helpdesk",
		API:                 "UpdateHelpdeskAgentSchedule",
		Method:              "PATCH",
		URL:                 r.cli.openBaseURL + "/open-apis/helpdesk/v1/agents/:agent_id/schedules",
		Body:                request,
		MethodOption:        newMethodOption(options),
		NeedUserAccessToken: true,
		NeedHelpdeskAuth:    true,
	}
	resp := new(updateHelpdeskAgentScheduleResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockHelpdeskUpdateHelpdeskAgentSchedule mock HelpdeskUpdateHelpdeskAgentSchedule method
func (r *Mock) MockHelpdeskUpdateHelpdeskAgentSchedule(f func(ctx context.Context, request *UpdateHelpdeskAgentScheduleReq, options ...MethodOptionFunc) (*UpdateHelpdeskAgentScheduleResp, *Response, error)) {
	r.mockHelpdeskUpdateHelpdeskAgentSchedule = f
}

// UnMockHelpdeskUpdateHelpdeskAgentSchedule un-mock HelpdeskUpdateHelpdeskAgentSchedule method
func (r *Mock) UnMockHelpdeskUpdateHelpdeskAgentSchedule() {
	r.mockHelpdeskUpdateHelpdeskAgentSchedule = nil
}

// UpdateHelpdeskAgentScheduleReq ...
type UpdateHelpdeskAgentScheduleReq struct {
	AgentID       string                                       `path:"agent_id" json:"-"`        // 客服 id, 示例值: "123456"
	AgentSchedule *UpdateHelpdeskAgentScheduleReqAgentSchedule `json:"agent_schedule,omitempty"` // 工作日程列表
}

// UpdateHelpdeskAgentScheduleReqAgentSchedule ...
type UpdateHelpdeskAgentScheduleReqAgentSchedule struct {
	Schedule      []*UpdateHelpdeskAgentScheduleReqAgentScheduleSchedule `json:"schedule,omitempty"`        // 工作日程列表
	AgentSkillIDs []string                                               `json:"agent_skill_ids,omitempty"` // 客服技能 ids, 示例值: [“test-skill-id”]
}

// UpdateHelpdeskAgentScheduleReqAgentScheduleSchedule ...
type UpdateHelpdeskAgentScheduleReqAgentScheduleSchedule struct {
	StartTime *string `json:"start_time,omitempty"` // 开始时间, format 00:00 - 23:59, 示例值: "00:00"
	EndTime   *string `json:"end_time,omitempty"`   // 结束时间, format 00:00 - 23:59, 示例值: "24:00"
	Weekday   *int64  `json:"weekday,omitempty"`    // 星期几, 1 - Monday, 2 - Tuesday, 3 - Wednesday, 4 - Thursday, 5 - Friday, 6 - Saturday, 7 - Sunday, 9 - Everday, 10 - Weekday, 11 - Weekend, 示例值: 9
}

// UpdateHelpdeskAgentScheduleResp ...
type UpdateHelpdeskAgentScheduleResp struct {
}

// updateHelpdeskAgentScheduleResp ...
type updateHelpdeskAgentScheduleResp struct {
	Code int64                            `json:"code,omitempty"` // 错误码, 非 0 表示失败
	Msg  string                           `json:"msg,omitempty"`  // 错误描述
	Data *UpdateHelpdeskAgentScheduleResp `json:"data,omitempty"`
}
