// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// GetHireApplication 根据投递 ID 获取单个投递信息
//
// doc: https://open.feishu.cn/document/ukTMukTMukTM/uMzM1YjLzMTN24yMzUjN/hire-v1/application/get
func (r *HireService) GetHireApplication(ctx context.Context, request *GetHireApplicationReq, options ...MethodOptionFunc) (*GetHireApplicationResp, *Response, error) {
	if r.cli.mock.mockHireGetHireApplication != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] Hire#GetHireApplication mock enable")
		return r.cli.mock.mockHireGetHireApplication(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:                 "Hire",
		API:                   "GetHireApplication",
		Method:                "GET",
		URL:                   r.cli.openBaseURL + "/open-apis/hire/v1/applications/:application_id",
		Body:                  request,
		MethodOption:          newMethodOption(options),
		NeedTenantAccessToken: true,
	}
	resp := new(getHireApplicationResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockHireGetHireApplication mock HireGetHireApplication method
func (r *Mock) MockHireGetHireApplication(f func(ctx context.Context, request *GetHireApplicationReq, options ...MethodOptionFunc) (*GetHireApplicationResp, *Response, error)) {
	r.mockHireGetHireApplication = f
}

// UnMockHireGetHireApplication un-mock HireGetHireApplication method
func (r *Mock) UnMockHireGetHireApplication() {
	r.mockHireGetHireApplication = nil
}

// GetHireApplicationReq ...
type GetHireApplicationReq struct {
	ApplicationID string `path:"application_id" json:"-"` // 投递 ID, 示例值: "6949805467799537964"
}

// GetHireApplicationResp ...
type GetHireApplicationResp struct {
	Application *GetHireApplicationRespApplication `json:"application,omitempty"` // 投递数据
}

// GetHireApplicationRespApplication ...
type GetHireApplicationRespApplication struct {
	ID                           string                                                       `json:"id,omitempty"`                              // 投递id
	JobID                        string                                                       `json:"job_id,omitempty"`                          // 投递的职位 ID
	TalentID                     string                                                       `json:"talent_id,omitempty"`                       // 候选人 ID
	ResumeResourceID             string                                                       `json:"resume_resource_id,omitempty"`              // 简历来源 ID
	Stage                        *GetHireApplicationRespApplicationStage                      `json:"stage,omitempty"`                           // 投递处于的阶段
	ActiveStatus                 int64                                                        `json:"active_status,omitempty"`                   // 活跃状态, 可选值有: 1: 活跃, 2: 非活跃, 即为「已终止」, 3: 全部
	DeliveryType                 int64                                                        `json:"delivery_type,omitempty"`                   // 投递方式, 可选值有: 1: HR寻访, 2: 候选人主动投递
	ResumeSourceInfo             *GetHireApplicationRespApplicationResumeSourceInfo           `json:"resume_source_info,omitempty"`              // 投递来源信息
	WebsiteResumeSource          *GetHireApplicationRespApplicationWebsiteResumeSource        `json:"website_resume_source,omitempty"`           // 官网投递来源
	TalentAttachmentResumeID     string                                                       `json:"talent_attachment_resume_id,omitempty"`     // 简历附件 ID
	CreateTime                   string                                                       `json:"create_time,omitempty"`                     // 创建时间
	ModifyTime                   string                                                       `json:"modify_time,omitempty"`                     // 修改时间
	StageTimeList                []*GetHireApplicationRespApplicationStageTime                `json:"stage_time_list,omitempty"`                 // 阶段变更时间列表
	TerminationType              int64                                                        `json:"termination_type,omitempty"`                // 终止原因的类型, 可选值有: 1: 我们拒绝了候选人, 22: 候选人拒绝了我们, 27: 其他
	TerminationReasonList        []string                                                     `json:"termination_reason_list,omitempty"`         // 终止的具体原因的id列表
	TerminationReasonNote        string                                                       `json:"termination_reason_note,omitempty"`         // 终止备注
	ApplicationPreferredCityList []*GetHireApplicationRespApplicationApplicationPreferredCity `json:"application_preferred_city_list,omitempty"` // 意向投递城市列表
}

// GetHireApplicationRespApplicationApplicationPreferredCity ...
type GetHireApplicationRespApplicationApplicationPreferredCity struct {
	Code string                                                         `json:"code,omitempty"` // 编码
	Name *GetHireApplicationRespApplicationApplicationPreferredCityName `json:"name,omitempty"` // 名称
}

// GetHireApplicationRespApplicationApplicationPreferredCityName ...
type GetHireApplicationRespApplicationApplicationPreferredCityName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireApplicationRespApplicationResumeSourceInfo ...
type GetHireApplicationRespApplicationResumeSourceInfo struct {
	ID               string                                                 `json:"id,omitempty"`                 // 投递来源 ID
	Name             *GetHireApplicationRespApplicationResumeSourceInfoName `json:"name,omitempty"`               // 投递来源名称
	ResumeSourceType int64                                                  `json:"resume_source_type,omitempty"` // 投递来源类型, 可选值有: 10000: 内推, 10001: 猎头, 10002: 内部来源, 10003: 第三方招聘网站, 10004: 社交媒体, 10005: 线下来源, 10006: 其他, 10007: 外部推荐, 10008: 员工转岗, 10009: 实习生转正
}

// GetHireApplicationRespApplicationResumeSourceInfoName ...
type GetHireApplicationRespApplicationResumeSourceInfoName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireApplicationRespApplicationStage ...
type GetHireApplicationRespApplicationStage struct {
	ID     string `json:"id,omitempty"`      // 阶段 ID
	ZhName string `json:"zh_name,omitempty"` // 阶段中文名字
	EnName string `json:"en_name,omitempty"` // 英文名
	Type   int64  `json:"type,omitempty"`    // 阶段类型, 可选值有: 1: 筛选型, 2: 评估型, 3: 笔试型, 4: 面试型, 5: Offer型, 6: 待入职, 7: 已入职, 8: 其它类型, 255: 系统默认
}

// GetHireApplicationRespApplicationStageTime ...
type GetHireApplicationRespApplicationStageTime struct {
	StageID   string `json:"stage_id,omitempty"`   // 阶段 ID
	EnterTime string `json:"enter_time,omitempty"` // 最近一次进入该阶段的时间
	ExitTime  string `json:"exit_time,omitempty"`  // 最后一次离开时间, 如当前在该阶段, 则为空
}

// GetHireApplicationRespApplicationWebsiteResumeSource ...
type GetHireApplicationRespApplicationWebsiteResumeSource struct {
	WebsiteID   string                                                           `json:"website_id,omitempty"`   // 官网站点 ID
	WebsiteName *GetHireApplicationRespApplicationWebsiteResumeSourceWebsiteName `json:"website_name,omitempty"` // 官网站点名称
	Channel     *GetHireApplicationRespApplicationWebsiteResumeSourceChannel     `json:"channel,omitempty"`      // 推广渠道来源
}

// GetHireApplicationRespApplicationWebsiteResumeSourceChannel ...
type GetHireApplicationRespApplicationWebsiteResumeSourceChannel struct {
	ChannelID   string                                                                  `json:"channel_id,omitempty"`   // 官网推广渠道 ID
	ChannelName *GetHireApplicationRespApplicationWebsiteResumeSourceChannelChannelName `json:"channel_name,omitempty"` // 官网推广渠道名称
}

// GetHireApplicationRespApplicationWebsiteResumeSourceChannelChannelName ...
type GetHireApplicationRespApplicationWebsiteResumeSourceChannelChannelName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireApplicationRespApplicationWebsiteResumeSourceWebsiteName ...
type GetHireApplicationRespApplicationWebsiteResumeSourceWebsiteName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// getHireApplicationResp ...
type getHireApplicationResp struct {
	Code int64                   `json:"code,omitempty"` // 错误码, 非 0 表示失败
	Msg  string                  `json:"msg,omitempty"`  // 错误描述
	Data *GetHireApplicationResp `json:"data,omitempty"`
}
