// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// GetHireTalent 根据人才 ID 获取人才信息
//
// doc: https://open.feishu.cn/document/ukTMukTMukTM/uMzM1YjLzMTN24yMzUjN/hire-v1/talent/get
func (r *HireService) GetHireTalent(ctx context.Context, request *GetHireTalentReq, options ...MethodOptionFunc) (*GetHireTalentResp, *Response, error) {
	if r.cli.mock.mockHireGetHireTalent != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] Hire#GetHireTalent mock enable")
		return r.cli.mock.mockHireGetHireTalent(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:                 "Hire",
		API:                   "GetHireTalent",
		Method:                "GET",
		URL:                   r.cli.openBaseURL + "/open-apis/hire/v1/talents/:talent_id",
		Body:                  request,
		MethodOption:          newMethodOption(options),
		NeedTenantAccessToken: true,
	}
	resp := new(getHireTalentResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockHireGetHireTalent mock HireGetHireTalent method
func (r *Mock) MockHireGetHireTalent(f func(ctx context.Context, request *GetHireTalentReq, options ...MethodOptionFunc) (*GetHireTalentResp, *Response, error)) {
	r.mockHireGetHireTalent = f
}

// UnMockHireGetHireTalent un-mock HireGetHireTalent method
func (r *Mock) UnMockHireGetHireTalent() {
	r.mockHireGetHireTalent = nil
}

// GetHireTalentReq ...
type GetHireTalentReq struct {
	TalentID string `path:"talent_id" json:"-"` // 人才ID, 示例值: "6891560630172518670"
}

// GetHireTalentResp ...
type GetHireTalentResp struct {
	Talent *GetHireTalentRespTalent `json:"talent,omitempty"` // 人才信息
}

// GetHireTalentRespTalent ...
type GetHireTalentRespTalent struct {
	ID                        string                                          `json:"id,omitempty"`                          // 人才ID
	IsInAgencyPeriod          bool                                            `json:"is_in_agency_period,omitempty"`         // 是否在猎头保护期, 可选值有: false: 未在猎头保护期, true: 在猎头保护期
	IsOnboarded               bool                                            `json:"is_onboarded,omitempty"`                // 是否已入职, 可选值有: false: 未入职, true: 已入职
	BasicInfo                 *GetHireTalentRespTalentBasicInfo               `json:"basic_info,omitempty"`                  // 基础信息
	EducationList             []*GetHireTalentRespTalentEducation             `json:"education_list,omitempty"`              // 教育经历
	CareerList                []*GetHireTalentRespTalentCareer                `json:"career_list,omitempty"`                 // 工作经历
	ProjectList               []*GetHireTalentRespTalentProject               `json:"project_list,omitempty"`                // 项目经历
	WorksList                 []*GetHireTalentRespTalentWorks                 `json:"works_list,omitempty"`                  // 作品
	AwardList                 []*GetHireTalentRespTalentAward                 `json:"award_list,omitempty"`                  // 获奖
	LanguageList              []*GetHireTalentRespTalentLanguage              `json:"language_list,omitempty"`               // 语言能力
	SnsList                   []*GetHireTalentRespTalentSns                   `json:"sns_list,omitempty"`                    // 社交账号
	ResumeSourceList          []*GetHireTalentRespTalentResumeSource          `json:"resume_source_list,omitempty"`          // 简历来源
	InterviewRegistrationList []*GetHireTalentRespTalentInterviewRegistration `json:"interview_registration_list,omitempty"` // 面试登记表
	ResumeAttachmentIDList    []string                                        `json:"resume_attachment_id_list,omitempty"`   // 简历附件id列表（按照简历创建时间降序）
	CustomizedDataList        []*GetHireTalentRespTalentCustomizedData        `json:"customized_data_list,omitempty"`        // 自定义模块
	TopDegree                 int64                                           `json:"top_degree,omitempty"`                  // 最高学历, 可选值有: 1: 小学, 2: 初中, 3: 专职, 4: 高中, 5: 大专, 6: 本科, 7: 硕士, 8: 博士, 9: 其他
}

// GetHireTalentRespTalentAward ...
type GetHireTalentRespTalentAward struct {
	ID                 string                                        `json:"id,omitempty"`                   // ID
	Title              string                                        `json:"title,omitempty"`                // 获奖名称
	AwardTime          string                                        `json:"award_time,omitempty"`           // 获奖时间
	Desc               string                                        `json:"desc,omitempty"`                 // 描述
	CustomizedDataList []*GetHireTalentRespTalentAwardCustomizedData `json:"customized_data_list,omitempty"` // 自定义字段
}

// GetHireTalentRespTalentAwardCustomizedData ...
type GetHireTalentRespTalentAwardCustomizedData struct {
	ObjectID   string                                           `json:"object_id,omitempty"`   // 自定义字段 ID
	Name       *GetHireTalentRespTalentAwardCustomizedDataName  `json:"name,omitempty"`        // 字段名称
	ObjectType int64                                            `json:"object_type,omitempty"` // 字段类型, 可选值有: 1: 单行文本, 2: 多行文本, 3: 单选, 4: 多选, 5: 日期, 6: 月份选择, 7: 年份选择, 8: 时间段, 9: 数字, 10: 默认字段, 11: 模块, 13: 附件
	Value      *GetHireTalentRespTalentAwardCustomizedDataValue `json:"value,omitempty"`       // 自定义字段值
}

// GetHireTalentRespTalentAwardCustomizedDataName ...
type GetHireTalentRespTalentAwardCustomizedDataName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentAwardCustomizedDataValue ...
type GetHireTalentRespTalentAwardCustomizedDataValue struct {
	Content              string                                                                 `json:"content,omitempty"`               // 当字段类型为单行文本、多行文本、模块、默认字段时, 从此字段取值
	Option               *GetHireTalentRespTalentAwardCustomizedDataValueOption                 `json:"option,omitempty"`                // 当字段类型为单选时, 从此字段取值
	OptionList           []*GetHireTalentRespTalentAwardCustomizedDataValueOption               `json:"option_list,omitempty"`           // 当字段类型为多选时, 从此字段取值
	TimeRange            *GetHireTalentRespTalentAwardCustomizedDataValueTimeRange              `json:"time_range,omitempty"`            // 当字段类型为时间段时, 从此字段取值
	Time                 string                                                                 `json:"time,omitempty"`                  // 当字段类型为日期选择、月份选择、年份选择时, 从此字段取值, 该字段是秒级时间戳
	Number               string                                                                 `json:"number,omitempty"`                // 当字段类型为数字时, 从此字段取值
	CustomizedAttachment []*GetHireTalentRespTalentAwardCustomizedDataValueCustomizedAttachment `json:"customized_attachment,omitempty"` // 当字段类型为附件时, 从此字段取值
}

// GetHireTalentRespTalentAwardCustomizedDataValueCustomizedAttachment ...
type GetHireTalentRespTalentAwardCustomizedDataValueCustomizedAttachment struct {
	FileID      string `json:"file_id,omitempty"`      // 附件 ID
	FileName    string `json:"file_name,omitempty"`    // 附件名称
	ContentType string `json:"content_type,omitempty"` // 附件类型
	FileSize    string `json:"file_size,omitempty"`    // 附件大小
}

// GetHireTalentRespTalentAwardCustomizedDataValueOption ...
type GetHireTalentRespTalentAwardCustomizedDataValueOption struct {
	Key  string                                                     `json:"key,omitempty"`  // 选项 ID
	Name *GetHireTalentRespTalentAwardCustomizedDataValueOptionName `json:"name,omitempty"` // 选项名称
}

// GetHireTalentRespTalentAwardCustomizedDataValueOptionName ...
type GetHireTalentRespTalentAwardCustomizedDataValueOptionName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentAwardCustomizedDataValueTimeRange ...
type GetHireTalentRespTalentAwardCustomizedDataValueTimeRange struct {
	StartTime string `json:"start_time,omitempty"` // 开始时间
	EndTime   string `json:"end_time,omitempty"`   // 结束时间, 当值为至今时, 返回「-」
}

// GetHireTalentRespTalentBasicInfo ...
type GetHireTalentRespTalentBasicInfo struct {
	Name                 string                                            `json:"name,omitempty"`                  // 名字
	Mobile               string                                            `json:"mobile,omitempty"`                // 手机
	MobileCode           string                                            `json:"mobile_code,omitempty"`           // 手机国家区号
	MobileCountryCode    string                                            `json:"mobile_country_code,omitempty"`   // 手机国家代码
	Email                string                                            `json:"email,omitempty"`                 // 邮箱
	ExperienceYears      int64                                             `json:"experience_years,omitempty"`      // 工作年限
	Age                  int64                                             `json:"age,omitempty"`                   // 年龄
	Nationality          *GetHireTalentRespTalentBasicInfoNationality      `json:"nationality,omitempty"`           // 国籍
	Gender               int64                                             `json:"gender,omitempty"`                // 性别, 可选值有: 1: 男, 2: 女, 3: 其他
	CurrentCity          *GetHireTalentRespTalentBasicInfoCurrentCity      `json:"current_city,omitempty"`          // 所在地点
	HometownCity         *GetHireTalentRespTalentBasicInfoHometownCity     `json:"hometown_city,omitempty"`         // 家乡
	PreferredCityList    []*GetHireTalentRespTalentBasicInfoPreferredCity  `json:"preferred_city_list,omitempty"`   // 意向地点
	IdentificationType   int64                                             `json:"identification_type,omitempty"`   // 证件类型, 可选值有: 1: 中国 - 居民身份证, 2: 护照, 3: 中国 - 港澳居民居住证, 4: 中国 - 台湾居民来往大陆通行证, 5: 其他, 6: 中国 - 港澳居民来往内地通行证, 9: 中国 - 台湾居民居住证
	IdentificationNumber string                                            `json:"identification_number,omitempty"` // 证件号
	Identification       *GetHireTalentRespTalentBasicInfoIdentification   `json:"identification,omitempty"`        // 证件信息
	Birthday             int64                                             `json:"birthday,omitempty"`              // 生日
	CreatorID            string                                            `json:"creator_id,omitempty"`            // 创建人
	MaritalStatus        int64                                             `json:"marital_status,omitempty"`        // 婚姻状况, 可选值有: 1: 已婚, 2: 未婚
	CurrentHomeAddress   string                                            `json:"current_home_address,omitempty"`  // 家庭住址
	CustomizedDataList   []*GetHireTalentRespTalentBasicInfoCustomizedData `json:"customized_data_list,omitempty"`  // 自定义字段
	ModifyTime           string                                            `json:"modify_time,omitempty"`           // 修改时间
}

// GetHireTalentRespTalentBasicInfoCurrentCity ...
type GetHireTalentRespTalentBasicInfoCurrentCity struct {
	CityCode string `json:"city_code,omitempty"` // 城市码
	ZhName   string `json:"zh_name,omitempty"`   // 中文名
	EnName   string `json:"en_name,omitempty"`   // 英文名
}

// GetHireTalentRespTalentBasicInfoCustomizedData ...
type GetHireTalentRespTalentBasicInfoCustomizedData struct {
	ObjectID   string                                               `json:"object_id,omitempty"`   // 自定义字段 ID
	Name       *GetHireTalentRespTalentBasicInfoCustomizedDataName  `json:"name,omitempty"`        // 字段名称
	ObjectType int64                                                `json:"object_type,omitempty"` // 字段类型, 可选值有: 1: 单行文本, 2: 多行文本, 3: 单选, 4: 多选, 5: 日期, 6: 月份选择, 7: 年份选择, 8: 时间段, 9: 数字, 10: 默认字段, 11: 模块, 13: 附件
	Value      *GetHireTalentRespTalentBasicInfoCustomizedDataValue `json:"value,omitempty"`       // 自定义字段值
}

// GetHireTalentRespTalentBasicInfoCustomizedDataName ...
type GetHireTalentRespTalentBasicInfoCustomizedDataName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentBasicInfoCustomizedDataValue ...
type GetHireTalentRespTalentBasicInfoCustomizedDataValue struct {
	Content              string                                                                     `json:"content,omitempty"`               // 当字段类型为单行文本、多行文本、模块、默认字段时, 从此字段取值
	Option               *GetHireTalentRespTalentBasicInfoCustomizedDataValueOption                 `json:"option,omitempty"`                // 当字段类型为单选时, 从此字段取值
	OptionList           []*GetHireTalentRespTalentBasicInfoCustomizedDataValueOption               `json:"option_list,omitempty"`           // 当字段类型为多选时, 从此字段取值
	TimeRange            *GetHireTalentRespTalentBasicInfoCustomizedDataValueTimeRange              `json:"time_range,omitempty"`            // 当字段类型为时间段时, 从此字段取值
	Time                 string                                                                     `json:"time,omitempty"`                  // 当字段类型为日期选择、月份选择、年份选择时, 从此字段取值, 该字段是秒级时间戳
	Number               string                                                                     `json:"number,omitempty"`                // 当字段类型为数字时, 从此字段取值
	CustomizedAttachment []*GetHireTalentRespTalentBasicInfoCustomizedDataValueCustomizedAttachment `json:"customized_attachment,omitempty"` // 当字段类型为附件时, 从此字段取值
}

// GetHireTalentRespTalentBasicInfoCustomizedDataValueCustomizedAttachment ...
type GetHireTalentRespTalentBasicInfoCustomizedDataValueCustomizedAttachment struct {
	FileID      string `json:"file_id,omitempty"`      // 附件 ID
	FileName    string `json:"file_name,omitempty"`    // 附件名称
	ContentType string `json:"content_type,omitempty"` // 附件类型
	FileSize    string `json:"file_size,omitempty"`    // 附件大小
}

// GetHireTalentRespTalentBasicInfoCustomizedDataValueOption ...
type GetHireTalentRespTalentBasicInfoCustomizedDataValueOption struct {
	Key  string                                                         `json:"key,omitempty"`  // 选项 ID
	Name *GetHireTalentRespTalentBasicInfoCustomizedDataValueOptionName `json:"name,omitempty"` // 选项名称
}

// GetHireTalentRespTalentBasicInfoCustomizedDataValueOptionName ...
type GetHireTalentRespTalentBasicInfoCustomizedDataValueOptionName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentBasicInfoCustomizedDataValueTimeRange ...
type GetHireTalentRespTalentBasicInfoCustomizedDataValueTimeRange struct {
	StartTime string `json:"start_time,omitempty"` // 开始时间
	EndTime   string `json:"end_time,omitempty"`   // 结束时间, 当值为至今时, 返回「-」
}

// GetHireTalentRespTalentBasicInfoHometownCity ...
type GetHireTalentRespTalentBasicInfoHometownCity struct {
	CityCode string `json:"city_code,omitempty"` // 城市码
	ZhName   string `json:"zh_name,omitempty"`   // 中文名
	EnName   string `json:"en_name,omitempty"`   // 英文名
}

// GetHireTalentRespTalentBasicInfoIdentification ...
type GetHireTalentRespTalentBasicInfoIdentification struct {
	IdentificationType   int64  `json:"identification_type,omitempty"`   // 证件类型, 可选值有: 1: 中国 - 居民身份证, 2: 护照, 3: 中国 - 港澳居民居住证, 4: 中国 - 台湾居民来往大陆通行证, 5: 其他, 6: 中国 - 港澳居民来往内地通行证, 9: 中国 - 台湾居民居住证
	IdentificationNumber string `json:"identification_number,omitempty"` // 证件号
}

// GetHireTalentRespTalentBasicInfoNationality ...
type GetHireTalentRespTalentBasicInfoNationality struct {
	NationalityCode string `json:"nationality_code,omitempty"` // 国家编码
	ZhName          string `json:"zh_name,omitempty"`          // 中文名
	EnName          string `json:"en_name,omitempty"`          // 英文名
}

// GetHireTalentRespTalentBasicInfoPreferredCity ...
type GetHireTalentRespTalentBasicInfoPreferredCity struct {
	CityCode string `json:"city_code,omitempty"` // 城市码
	ZhName   string `json:"zh_name,omitempty"`   // 中文名
	EnName   string `json:"en_name,omitempty"`   // 英文名
}

// GetHireTalentRespTalentCareer ...
type GetHireTalentRespTalentCareer struct {
	ID                 string                                         `json:"id,omitempty"`                   // ID
	Company            string                                         `json:"company,omitempty"`              // 公司名称
	Title              string                                         `json:"title,omitempty"`                // 职位名称
	Desc               string                                         `json:"desc,omitempty"`                 // 描述
	StartTime          string                                         `json:"start_time,omitempty"`           // 开始时间
	EndTime            string                                         `json:"end_time,omitempty"`             // 结束时间
	CareerType         int64                                          `json:"career_type,omitempty"`          // 经历类型, 可选值有: 1: 实习经历, 2: 工作经历
	TagList            []int64                                        `json:"tag_list,omitempty"`             // 工作经历标签, 可选值有: 5: 百度 阿里 腾讯, 6: 头条, 美团, 滴滴, 7: 其它大厂
	CustomizedDataList []*GetHireTalentRespTalentCareerCustomizedData `json:"customized_data_list,omitempty"` // 自定义字段
}

// GetHireTalentRespTalentCareerCustomizedData ...
type GetHireTalentRespTalentCareerCustomizedData struct {
	ObjectID   string                                            `json:"object_id,omitempty"`   // 自定义字段 ID
	Name       *GetHireTalentRespTalentCareerCustomizedDataName  `json:"name,omitempty"`        // 字段名称
	ObjectType int64                                             `json:"object_type,omitempty"` // 字段类型, 可选值有: 1: 单行文本, 2: 多行文本, 3: 单选, 4: 多选, 5: 日期, 6: 月份选择, 7: 年份选择, 8: 时间段, 9: 数字, 10: 默认字段, 11: 模块, 13: 附件
	Value      *GetHireTalentRespTalentCareerCustomizedDataValue `json:"value,omitempty"`       // 自定义字段值
}

// GetHireTalentRespTalentCareerCustomizedDataName ...
type GetHireTalentRespTalentCareerCustomizedDataName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentCareerCustomizedDataValue ...
type GetHireTalentRespTalentCareerCustomizedDataValue struct {
	Content              string                                                                  `json:"content,omitempty"`               // 当字段类型为单行文本、多行文本、模块、默认字段时, 从此字段取值
	Option               *GetHireTalentRespTalentCareerCustomizedDataValueOption                 `json:"option,omitempty"`                // 当字段类型为单选时, 从此字段取值
	OptionList           []*GetHireTalentRespTalentCareerCustomizedDataValueOption               `json:"option_list,omitempty"`           // 当字段类型为多选时, 从此字段取值
	TimeRange            *GetHireTalentRespTalentCareerCustomizedDataValueTimeRange              `json:"time_range,omitempty"`            // 当字段类型为时间段时, 从此字段取值
	Time                 string                                                                  `json:"time,omitempty"`                  // 当字段类型为日期选择、月份选择、年份选择时, 从此字段取值, 该字段是秒级时间戳
	Number               string                                                                  `json:"number,omitempty"`                // 当字段类型为数字时, 从此字段取值
	CustomizedAttachment []*GetHireTalentRespTalentCareerCustomizedDataValueCustomizedAttachment `json:"customized_attachment,omitempty"` // 当字段类型为附件时, 从此字段取值
}

// GetHireTalentRespTalentCareerCustomizedDataValueCustomizedAttachment ...
type GetHireTalentRespTalentCareerCustomizedDataValueCustomizedAttachment struct {
	FileID      string `json:"file_id,omitempty"`      // 附件 ID
	FileName    string `json:"file_name,omitempty"`    // 附件名称
	ContentType string `json:"content_type,omitempty"` // 附件类型
	FileSize    string `json:"file_size,omitempty"`    // 附件大小
}

// GetHireTalentRespTalentCareerCustomizedDataValueOption ...
type GetHireTalentRespTalentCareerCustomizedDataValueOption struct {
	Key  string                                                      `json:"key,omitempty"`  // 选项 ID
	Name *GetHireTalentRespTalentCareerCustomizedDataValueOptionName `json:"name,omitempty"` // 选项名称
}

// GetHireTalentRespTalentCareerCustomizedDataValueOptionName ...
type GetHireTalentRespTalentCareerCustomizedDataValueOptionName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentCareerCustomizedDataValueTimeRange ...
type GetHireTalentRespTalentCareerCustomizedDataValueTimeRange struct {
	StartTime string `json:"start_time,omitempty"` // 开始时间
	EndTime   string `json:"end_time,omitempty"`   // 结束时间, 当值为至今时, 返回「-」
}

// GetHireTalentRespTalentCustomizedData ...
type GetHireTalentRespTalentCustomizedData struct {
	ObjectID   string                                           `json:"object_id,omitempty"`   // 模块 ID
	Name       *GetHireTalentRespTalentCustomizedDataName       `json:"name,omitempty"`        // 模块名称
	ObjectType int64                                            `json:"object_type,omitempty"` // 类型, 可选值有: 1: 单行文本, 2: 多行文本, 3: 单选, 4: 多选, 5: 日期, 6: 月份选择, 7: 年份选择, 8: 时间段, 9: 数字, 10: 默认字段, 11: 模块
	Children   []*GetHireTalentRespTalentCustomizedDataChildren `json:"children,omitempty"`    // 模块下的字段
}

// GetHireTalentRespTalentCustomizedDataChildren ...
type GetHireTalentRespTalentCustomizedDataChildren struct {
	ObjectID   string                                              `json:"object_id,omitempty"`   // 自定义字段 ID
	Name       *GetHireTalentRespTalentCustomizedDataChildrenName  `json:"name,omitempty"`        // 字段名称
	ObjectType int64                                               `json:"object_type,omitempty"` // 字段类型, 可选值有: 1: 单行文本, 2: 多行文本, 3: 单选, 4: 多选, 5: 日期, 6: 月份选择, 7: 年份选择, 8: 时间段, 9: 数字, 10: 默认字段, 11: 模块, 13: 附件
	Value      *GetHireTalentRespTalentCustomizedDataChildrenValue `json:"value,omitempty"`       // 自定义字段值
}

// GetHireTalentRespTalentCustomizedDataChildrenName ...
type GetHireTalentRespTalentCustomizedDataChildrenName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentCustomizedDataChildrenValue ...
type GetHireTalentRespTalentCustomizedDataChildrenValue struct {
	Content              string                                                                    `json:"content,omitempty"`               // 当字段类型为单行文本、多行文本、模块、默认字段时, 从此字段取值
	Option               *GetHireTalentRespTalentCustomizedDataChildrenValueOption                 `json:"option,omitempty"`                // 当字段类型为单选时, 从此字段取值
	OptionList           []*GetHireTalentRespTalentCustomizedDataChildrenValueOption               `json:"option_list,omitempty"`           // 当字段类型为多选时, 从此字段取值
	TimeRange            *GetHireTalentRespTalentCustomizedDataChildrenValueTimeRange              `json:"time_range,omitempty"`            // 当字段类型为时间段时, 从此字段取值
	Time                 string                                                                    `json:"time,omitempty"`                  // 当字段类型为日期选择、月份选择、年份选择时, 从此字段取值, 该字段是秒级时间戳
	Number               string                                                                    `json:"number,omitempty"`                // 当字段类型为数字时, 从此字段取值
	CustomizedAttachment []*GetHireTalentRespTalentCustomizedDataChildrenValueCustomizedAttachment `json:"customized_attachment,omitempty"` // 当字段类型为附件时, 从此字段取值
}

// GetHireTalentRespTalentCustomizedDataChildrenValueCustomizedAttachment ...
type GetHireTalentRespTalentCustomizedDataChildrenValueCustomizedAttachment struct {
	FileID      string `json:"file_id,omitempty"`      // 附件 ID
	FileName    string `json:"file_name,omitempty"`    // 附件名称
	ContentType string `json:"content_type,omitempty"` // 附件类型
	FileSize    string `json:"file_size,omitempty"`    // 附件大小
}

// GetHireTalentRespTalentCustomizedDataChildrenValueOption ...
type GetHireTalentRespTalentCustomizedDataChildrenValueOption struct {
	Key  string                                                        `json:"key,omitempty"`  // 选项 ID
	Name *GetHireTalentRespTalentCustomizedDataChildrenValueOptionName `json:"name,omitempty"` // 选项名称
}

// GetHireTalentRespTalentCustomizedDataChildrenValueOptionName ...
type GetHireTalentRespTalentCustomizedDataChildrenValueOptionName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentCustomizedDataChildrenValueTimeRange ...
type GetHireTalentRespTalentCustomizedDataChildrenValueTimeRange struct {
	StartTime string `json:"start_time,omitempty"` // 开始时间
	EndTime   string `json:"end_time,omitempty"`   // 结束时间, 当值为至今时, 返回「-」
}

// GetHireTalentRespTalentCustomizedDataName ...
type GetHireTalentRespTalentCustomizedDataName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentEducation ...
type GetHireTalentRespTalentEducation struct {
	ID                 string                                            `json:"id,omitempty"`                   // ID
	Degree             int64                                             `json:"degree,omitempty"`               // 学位, 可选值有: 1: 小学, 2: 初中, 3: 专职, 4: 高中, 5: 大专, 6: 本科, 7: 硕士, 8: 博士, 9: 其他
	School             string                                            `json:"school,omitempty"`               // 学校
	FieldOfStudy       string                                            `json:"field_of_study,omitempty"`       // 专业
	StartTime          string                                            `json:"start_time,omitempty"`           // 开始时间
	EndTime            string                                            `json:"end_time,omitempty"`             // 结束时间
	EducationType      int64                                             `json:"education_type,omitempty"`       // 学历类型, 可选值有: 1: 海外及港台, 2: 统招全日制, 3: 非全日制, 4: 自考, 5: 其他
	AcademicRanking    int64                                             `json:"academic_ranking,omitempty"`     // 成绩排名, 可选值有: 5: 前 5 %, 10: 前 10 %, 20: 前 20 %, 30: 前 30 %, 50: 前 50 %, -1: 其他
	TagList            []int64                                           `json:"tag_list,omitempty"`             // 教育经历标签, 可选值有: 1: 985学校, 2: 211学校, 3: 一本, 4: 国外院校QS200
	CustomizedDataList []*GetHireTalentRespTalentEducationCustomizedData `json:"customized_data_list,omitempty"` // 自定义字段
}

// GetHireTalentRespTalentEducationCustomizedData ...
type GetHireTalentRespTalentEducationCustomizedData struct {
	ObjectID   string                                               `json:"object_id,omitempty"`   // 自定义字段 ID
	Name       *GetHireTalentRespTalentEducationCustomizedDataName  `json:"name,omitempty"`        // 字段名称
	ObjectType int64                                                `json:"object_type,omitempty"` // 字段类型, 可选值有: 1: 单行文本, 2: 多行文本, 3: 单选, 4: 多选, 5: 日期, 6: 月份选择, 7: 年份选择, 8: 时间段, 9: 数字, 10: 默认字段, 11: 模块, 13: 附件
	Value      *GetHireTalentRespTalentEducationCustomizedDataValue `json:"value,omitempty"`       // 自定义字段值
}

// GetHireTalentRespTalentEducationCustomizedDataName ...
type GetHireTalentRespTalentEducationCustomizedDataName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentEducationCustomizedDataValue ...
type GetHireTalentRespTalentEducationCustomizedDataValue struct {
	Content              string                                                                     `json:"content,omitempty"`               // 当字段类型为单行文本、多行文本、模块、默认字段时, 从此字段取值
	Option               *GetHireTalentRespTalentEducationCustomizedDataValueOption                 `json:"option,omitempty"`                // 当字段类型为单选时, 从此字段取值
	OptionList           []*GetHireTalentRespTalentEducationCustomizedDataValueOption               `json:"option_list,omitempty"`           // 当字段类型为多选时, 从此字段取值
	TimeRange            *GetHireTalentRespTalentEducationCustomizedDataValueTimeRange              `json:"time_range,omitempty"`            // 当字段类型为时间段时, 从此字段取值
	Time                 string                                                                     `json:"time,omitempty"`                  // 当字段类型为日期选择、月份选择、年份选择时, 从此字段取值, 该字段是秒级时间戳
	Number               string                                                                     `json:"number,omitempty"`                // 当字段类型为数字时, 从此字段取值
	CustomizedAttachment []*GetHireTalentRespTalentEducationCustomizedDataValueCustomizedAttachment `json:"customized_attachment,omitempty"` // 当字段类型为附件时, 从此字段取值
}

// GetHireTalentRespTalentEducationCustomizedDataValueCustomizedAttachment ...
type GetHireTalentRespTalentEducationCustomizedDataValueCustomizedAttachment struct {
	FileID      string `json:"file_id,omitempty"`      // 附件 ID
	FileName    string `json:"file_name,omitempty"`    // 附件名称
	ContentType string `json:"content_type,omitempty"` // 附件类型
	FileSize    string `json:"file_size,omitempty"`    // 附件大小
}

// GetHireTalentRespTalentEducationCustomizedDataValueOption ...
type GetHireTalentRespTalentEducationCustomizedDataValueOption struct {
	Key  string                                                         `json:"key,omitempty"`  // 选项 ID
	Name *GetHireTalentRespTalentEducationCustomizedDataValueOptionName `json:"name,omitempty"` // 选项名称
}

// GetHireTalentRespTalentEducationCustomizedDataValueOptionName ...
type GetHireTalentRespTalentEducationCustomizedDataValueOptionName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentEducationCustomizedDataValueTimeRange ...
type GetHireTalentRespTalentEducationCustomizedDataValueTimeRange struct {
	StartTime string `json:"start_time,omitempty"` // 开始时间
	EndTime   string `json:"end_time,omitempty"`   // 结束时间, 当值为至今时, 返回「-」
}

// GetHireTalentRespTalentInterviewRegistration ...
type GetHireTalentRespTalentInterviewRegistration struct {
	ID               string `json:"id,omitempty"`                // ID
	RegistrationTime int64  `json:"registration_time,omitempty"` // 创建时间
}

// GetHireTalentRespTalentLanguage ...
type GetHireTalentRespTalentLanguage struct {
	ID                 string                                           `json:"id,omitempty"`                   // ID
	Language           int64                                            `json:"language,omitempty"`             // 语言, 可选值有: 1: 英语, 2: 法语, 3: 日语, 4: 韩语, 5: 德语, 6: 俄语, 7: 西班牙语, 8: 葡萄牙语, 9: 阿拉伯语, 10: 印地语, 11: 印度斯坦语, 12: 孟加拉语, 13: 豪萨语, 14: 旁遮普语, 15: 波斯语, 16: 斯瓦西里语, 17: 泰卢固语, 18: 土耳其语, 19: 意大利语, 20: 爪哇语, 21: 泰米尔语, 22: 马拉地语, 23: 越南语, 24: 普通话, 25: 粤语
	Proficiency        int64                                            `json:"proficiency,omitempty"`          // 精通程度, 可选值有: 1: 入门, 2: 日常会话, 3: 商务会话, 4: 无障碍沟通, 5: 母语
	CustomizedDataList []*GetHireTalentRespTalentLanguageCustomizedData `json:"customized_data_list,omitempty"` // 自定义字段
}

// GetHireTalentRespTalentLanguageCustomizedData ...
type GetHireTalentRespTalentLanguageCustomizedData struct {
	ObjectID   string                                              `json:"object_id,omitempty"`   // 自定义字段 ID
	Name       *GetHireTalentRespTalentLanguageCustomizedDataName  `json:"name,omitempty"`        // 字段名称
	ObjectType int64                                               `json:"object_type,omitempty"` // 字段类型, 可选值有: 1: 单行文本, 2: 多行文本, 3: 单选, 4: 多选, 5: 日期, 6: 月份选择, 7: 年份选择, 8: 时间段, 9: 数字, 10: 默认字段, 11: 模块, 13: 附件
	Value      *GetHireTalentRespTalentLanguageCustomizedDataValue `json:"value,omitempty"`       // 自定义字段值
}

// GetHireTalentRespTalentLanguageCustomizedDataName ...
type GetHireTalentRespTalentLanguageCustomizedDataName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentLanguageCustomizedDataValue ...
type GetHireTalentRespTalentLanguageCustomizedDataValue struct {
	Content              string                                                                    `json:"content,omitempty"`               // 当字段类型为单行文本、多行文本、模块、默认字段时, 从此字段取值
	Option               *GetHireTalentRespTalentLanguageCustomizedDataValueOption                 `json:"option,omitempty"`                // 当字段类型为单选时, 从此字段取值
	OptionList           []*GetHireTalentRespTalentLanguageCustomizedDataValueOption               `json:"option_list,omitempty"`           // 当字段类型为多选时, 从此字段取值
	TimeRange            *GetHireTalentRespTalentLanguageCustomizedDataValueTimeRange              `json:"time_range,omitempty"`            // 当字段类型为时间段时, 从此字段取值
	Time                 string                                                                    `json:"time,omitempty"`                  // 当字段类型为日期选择、月份选择、年份选择时, 从此字段取值, 该字段是秒级时间戳
	Number               string                                                                    `json:"number,omitempty"`                // 当字段类型为数字时, 从此字段取值
	CustomizedAttachment []*GetHireTalentRespTalentLanguageCustomizedDataValueCustomizedAttachment `json:"customized_attachment,omitempty"` // 当字段类型为附件时, 从此字段取值
}

// GetHireTalentRespTalentLanguageCustomizedDataValueCustomizedAttachment ...
type GetHireTalentRespTalentLanguageCustomizedDataValueCustomizedAttachment struct {
	FileID      string `json:"file_id,omitempty"`      // 附件 ID
	FileName    string `json:"file_name,omitempty"`    // 附件名称
	ContentType string `json:"content_type,omitempty"` // 附件类型
	FileSize    string `json:"file_size,omitempty"`    // 附件大小
}

// GetHireTalentRespTalentLanguageCustomizedDataValueOption ...
type GetHireTalentRespTalentLanguageCustomizedDataValueOption struct {
	Key  string                                                        `json:"key,omitempty"`  // 选项 ID
	Name *GetHireTalentRespTalentLanguageCustomizedDataValueOptionName `json:"name,omitempty"` // 选项名称
}

// GetHireTalentRespTalentLanguageCustomizedDataValueOptionName ...
type GetHireTalentRespTalentLanguageCustomizedDataValueOptionName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentLanguageCustomizedDataValueTimeRange ...
type GetHireTalentRespTalentLanguageCustomizedDataValueTimeRange struct {
	StartTime string `json:"start_time,omitempty"` // 开始时间
	EndTime   string `json:"end_time,omitempty"`   // 结束时间, 当值为至今时, 返回「-」
}

// GetHireTalentRespTalentProject ...
type GetHireTalentRespTalentProject struct {
	ID                 string                                          `json:"id,omitempty"`                   // ID
	Name               string                                          `json:"name,omitempty"`                 // 项目名称
	Role               string                                          `json:"role,omitempty"`                 // 项目角色
	Link               string                                          `json:"link,omitempty"`                 // 项目链接
	Desc               string                                          `json:"desc,omitempty"`                 // 描述
	StartTime          string                                          `json:"start_time,omitempty"`           // 开始时间
	EndTime            string                                          `json:"end_time,omitempty"`             // 结束时间
	CustomizedDataList []*GetHireTalentRespTalentProjectCustomizedData `json:"customized_data_list,omitempty"` // 自定义字段
}

// GetHireTalentRespTalentProjectCustomizedData ...
type GetHireTalentRespTalentProjectCustomizedData struct {
	ObjectID   string                                             `json:"object_id,omitempty"`   // 自定义字段 ID
	Name       *GetHireTalentRespTalentProjectCustomizedDataName  `json:"name,omitempty"`        // 字段名称
	ObjectType int64                                              `json:"object_type,omitempty"` // 字段类型, 可选值有: 1: 单行文本, 2: 多行文本, 3: 单选, 4: 多选, 5: 日期, 6: 月份选择, 7: 年份选择, 8: 时间段, 9: 数字, 10: 默认字段, 11: 模块, 13: 附件
	Value      *GetHireTalentRespTalentProjectCustomizedDataValue `json:"value,omitempty"`       // 自定义字段值
}

// GetHireTalentRespTalentProjectCustomizedDataName ...
type GetHireTalentRespTalentProjectCustomizedDataName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentProjectCustomizedDataValue ...
type GetHireTalentRespTalentProjectCustomizedDataValue struct {
	Content              string                                                                   `json:"content,omitempty"`               // 当字段类型为单行文本、多行文本、模块、默认字段时, 从此字段取值
	Option               *GetHireTalentRespTalentProjectCustomizedDataValueOption                 `json:"option,omitempty"`                // 当字段类型为单选时, 从此字段取值
	OptionList           []*GetHireTalentRespTalentProjectCustomizedDataValueOption               `json:"option_list,omitempty"`           // 当字段类型为多选时, 从此字段取值
	TimeRange            *GetHireTalentRespTalentProjectCustomizedDataValueTimeRange              `json:"time_range,omitempty"`            // 当字段类型为时间段时, 从此字段取值
	Time                 string                                                                   `json:"time,omitempty"`                  // 当字段类型为日期选择、月份选择、年份选择时, 从此字段取值, 该字段是秒级时间戳
	Number               string                                                                   `json:"number,omitempty"`                // 当字段类型为数字时, 从此字段取值
	CustomizedAttachment []*GetHireTalentRespTalentProjectCustomizedDataValueCustomizedAttachment `json:"customized_attachment,omitempty"` // 当字段类型为附件时, 从此字段取值
}

// GetHireTalentRespTalentProjectCustomizedDataValueCustomizedAttachment ...
type GetHireTalentRespTalentProjectCustomizedDataValueCustomizedAttachment struct {
	FileID      string `json:"file_id,omitempty"`      // 附件 ID
	FileName    string `json:"file_name,omitempty"`    // 附件名称
	ContentType string `json:"content_type,omitempty"` // 附件类型
	FileSize    string `json:"file_size,omitempty"`    // 附件大小
}

// GetHireTalentRespTalentProjectCustomizedDataValueOption ...
type GetHireTalentRespTalentProjectCustomizedDataValueOption struct {
	Key  string                                                       `json:"key,omitempty"`  // 选项 ID
	Name *GetHireTalentRespTalentProjectCustomizedDataValueOptionName `json:"name,omitempty"` // 选项名称
}

// GetHireTalentRespTalentProjectCustomizedDataValueOptionName ...
type GetHireTalentRespTalentProjectCustomizedDataValueOptionName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentProjectCustomizedDataValueTimeRange ...
type GetHireTalentRespTalentProjectCustomizedDataValueTimeRange struct {
	StartTime string `json:"start_time,omitempty"` // 开始时间
	EndTime   string `json:"end_time,omitempty"`   // 结束时间, 当值为至今时, 返回「-」
}

// GetHireTalentRespTalentResumeSource ...
type GetHireTalentRespTalentResumeSource struct {
	ID     string `json:"id,omitempty"`      // ID
	ZhName string `json:"zh_name,omitempty"` // 中文名
	EnName string `json:"en_name,omitempty"` // 英文名
}

// GetHireTalentRespTalentSns ...
type GetHireTalentRespTalentSns struct {
	ID                 string                                      `json:"id,omitempty"`                   // ID
	SnsType            int64                                       `json:"sns_type,omitempty"`             // SNS名称, 可选值有: 1: 领英, 2: 脉脉, 3: 微信, 4: 微博, 5: Github, 6: 知乎, 7: 脸书, 8: 推特, 9: Whatsapp, 10: 个人网站, 11: QQ
	Link               string                                      `json:"link,omitempty"`                 // URL/ID
	CustomizedDataList []*GetHireTalentRespTalentSnsCustomizedData `json:"customized_data_list,omitempty"` // 自定义字段
}

// GetHireTalentRespTalentSnsCustomizedData ...
type GetHireTalentRespTalentSnsCustomizedData struct {
	ObjectID   string                                         `json:"object_id,omitempty"`   // 自定义字段 ID
	Name       *GetHireTalentRespTalentSnsCustomizedDataName  `json:"name,omitempty"`        // 字段名称
	ObjectType int64                                          `json:"object_type,omitempty"` // 字段类型, 可选值有: 1: 单行文本, 2: 多行文本, 3: 单选, 4: 多选, 5: 日期, 6: 月份选择, 7: 年份选择, 8: 时间段, 9: 数字, 10: 默认字段, 11: 模块, 13: 附件
	Value      *GetHireTalentRespTalentSnsCustomizedDataValue `json:"value,omitempty"`       // 自定义字段值
}

// GetHireTalentRespTalentSnsCustomizedDataName ...
type GetHireTalentRespTalentSnsCustomizedDataName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentSnsCustomizedDataValue ...
type GetHireTalentRespTalentSnsCustomizedDataValue struct {
	Content              string                                                               `json:"content,omitempty"`               // 当字段类型为单行文本、多行文本、模块、默认字段时, 从此字段取值
	Option               *GetHireTalentRespTalentSnsCustomizedDataValueOption                 `json:"option,omitempty"`                // 当字段类型为单选时, 从此字段取值
	OptionList           []*GetHireTalentRespTalentSnsCustomizedDataValueOption               `json:"option_list,omitempty"`           // 当字段类型为多选时, 从此字段取值
	TimeRange            *GetHireTalentRespTalentSnsCustomizedDataValueTimeRange              `json:"time_range,omitempty"`            // 当字段类型为时间段时, 从此字段取值
	Time                 string                                                               `json:"time,omitempty"`                  // 当字段类型为日期选择、月份选择、年份选择时, 从此字段取值, 该字段是秒级时间戳
	Number               string                                                               `json:"number,omitempty"`                // 当字段类型为数字时, 从此字段取值
	CustomizedAttachment []*GetHireTalentRespTalentSnsCustomizedDataValueCustomizedAttachment `json:"customized_attachment,omitempty"` // 当字段类型为附件时, 从此字段取值
}

// GetHireTalentRespTalentSnsCustomizedDataValueCustomizedAttachment ...
type GetHireTalentRespTalentSnsCustomizedDataValueCustomizedAttachment struct {
	FileID      string `json:"file_id,omitempty"`      // 附件 ID
	FileName    string `json:"file_name,omitempty"`    // 附件名称
	ContentType string `json:"content_type,omitempty"` // 附件类型
	FileSize    string `json:"file_size,omitempty"`    // 附件大小
}

// GetHireTalentRespTalentSnsCustomizedDataValueOption ...
type GetHireTalentRespTalentSnsCustomizedDataValueOption struct {
	Key  string                                                   `json:"key,omitempty"`  // 选项 ID
	Name *GetHireTalentRespTalentSnsCustomizedDataValueOptionName `json:"name,omitempty"` // 选项名称
}

// GetHireTalentRespTalentSnsCustomizedDataValueOptionName ...
type GetHireTalentRespTalentSnsCustomizedDataValueOptionName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentSnsCustomizedDataValueTimeRange ...
type GetHireTalentRespTalentSnsCustomizedDataValueTimeRange struct {
	StartTime string `json:"start_time,omitempty"` // 开始时间
	EndTime   string `json:"end_time,omitempty"`   // 结束时间, 当值为至今时, 返回「-」
}

// GetHireTalentRespTalentWorks ...
type GetHireTalentRespTalentWorks struct {
	ID                 string                                        `json:"id,omitempty"`                   // ID
	Link               string                                        `json:"link,omitempty"`                 // 作品链接
	Desc               string                                        `json:"desc,omitempty"`                 // 描述
	Name               string                                        `json:"name,omitempty"`                 // 作品附件名称, 若需获取作品附件预览信息可调用「获取附件预览信息」接口
	CustomizedDataList []*GetHireTalentRespTalentWorksCustomizedData `json:"customized_data_list,omitempty"` // 自定义字段
}

// GetHireTalentRespTalentWorksCustomizedData ...
type GetHireTalentRespTalentWorksCustomizedData struct {
	ObjectID   string                                           `json:"object_id,omitempty"`   // 自定义字段 ID
	Name       *GetHireTalentRespTalentWorksCustomizedDataName  `json:"name,omitempty"`        // 字段名称
	ObjectType int64                                            `json:"object_type,omitempty"` // 字段类型, 可选值有: 1: 单行文本, 2: 多行文本, 3: 单选, 4: 多选, 5: 日期, 6: 月份选择, 7: 年份选择, 8: 时间段, 9: 数字, 10: 默认字段, 11: 模块, 13: 附件
	Value      *GetHireTalentRespTalentWorksCustomizedDataValue `json:"value,omitempty"`       // 自定义字段值
}

// GetHireTalentRespTalentWorksCustomizedDataName ...
type GetHireTalentRespTalentWorksCustomizedDataName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentWorksCustomizedDataValue ...
type GetHireTalentRespTalentWorksCustomizedDataValue struct {
	Content              string                                                                 `json:"content,omitempty"`               // 当字段类型为单行文本、多行文本、模块、默认字段时, 从此字段取值
	Option               *GetHireTalentRespTalentWorksCustomizedDataValueOption                 `json:"option,omitempty"`                // 当字段类型为单选时, 从此字段取值
	OptionList           []*GetHireTalentRespTalentWorksCustomizedDataValueOption               `json:"option_list,omitempty"`           // 当字段类型为多选时, 从此字段取值
	TimeRange            *GetHireTalentRespTalentWorksCustomizedDataValueTimeRange              `json:"time_range,omitempty"`            // 当字段类型为时间段时, 从此字段取值
	Time                 string                                                                 `json:"time,omitempty"`                  // 当字段类型为日期选择、月份选择、年份选择时, 从此字段取值, 该字段是秒级时间戳
	Number               string                                                                 `json:"number,omitempty"`                // 当字段类型为数字时, 从此字段取值
	CustomizedAttachment []*GetHireTalentRespTalentWorksCustomizedDataValueCustomizedAttachment `json:"customized_attachment,omitempty"` // 当字段类型为附件时, 从此字段取值
}

// GetHireTalentRespTalentWorksCustomizedDataValueCustomizedAttachment ...
type GetHireTalentRespTalentWorksCustomizedDataValueCustomizedAttachment struct {
	FileID      string `json:"file_id,omitempty"`      // 附件 ID
	FileName    string `json:"file_name,omitempty"`    // 附件名称
	ContentType string `json:"content_type,omitempty"` // 附件类型
	FileSize    string `json:"file_size,omitempty"`    // 附件大小
}

// GetHireTalentRespTalentWorksCustomizedDataValueOption ...
type GetHireTalentRespTalentWorksCustomizedDataValueOption struct {
	Key  string                                                     `json:"key,omitempty"`  // 选项 ID
	Name *GetHireTalentRespTalentWorksCustomizedDataValueOptionName `json:"name,omitempty"` // 选项名称
}

// GetHireTalentRespTalentWorksCustomizedDataValueOptionName ...
type GetHireTalentRespTalentWorksCustomizedDataValueOptionName struct {
	ZhCn string `json:"zh_cn,omitempty"` // 中文
	EnUs string `json:"en_us,omitempty"` // 英文
}

// GetHireTalentRespTalentWorksCustomizedDataValueTimeRange ...
type GetHireTalentRespTalentWorksCustomizedDataValueTimeRange struct {
	StartTime string `json:"start_time,omitempty"` // 开始时间
	EndTime   string `json:"end_time,omitempty"`   // 结束时间, 当值为至今时, 返回「-」
}

// getHireTalentResp ...
type getHireTalentResp struct {
	Code int64              `json:"code,omitempty"` // 错误码, 非 0 表示失败
	Msg  string             `json:"msg,omitempty"`  // 错误描述
	Data *GetHireTalentResp `json:"data,omitempty"`
}
