// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// DeleteMeetingRoomBuilding 该接口用于删除建筑物（办公大楼）。
//
// doc: https://open.feishu.cn/document/ukTMukTMukTM/uMzMxYjLzMTM24yMzEjN
func (r *MeetingRoomService) DeleteMeetingRoomBuilding(ctx context.Context, request *DeleteMeetingRoomBuildingReq, options ...MethodOptionFunc) (*DeleteMeetingRoomBuildingResp, *Response, error) {
	if r.cli.mock.mockMeetingRoomDeleteMeetingRoomBuilding != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] MeetingRoom#DeleteMeetingRoomBuilding mock enable")
		return r.cli.mock.mockMeetingRoomDeleteMeetingRoomBuilding(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:                 "MeetingRoom",
		API:                   "DeleteMeetingRoomBuilding",
		Method:                "POST",
		URL:                   r.cli.openBaseURL + "/open-apis/meeting_room/building/delete",
		Body:                  request,
		MethodOption:          newMethodOption(options),
		NeedTenantAccessToken: true,
	}
	resp := new(deleteMeetingRoomBuildingResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockMeetingRoomDeleteMeetingRoomBuilding mock MeetingRoomDeleteMeetingRoomBuilding method
func (r *Mock) MockMeetingRoomDeleteMeetingRoomBuilding(f func(ctx context.Context, request *DeleteMeetingRoomBuildingReq, options ...MethodOptionFunc) (*DeleteMeetingRoomBuildingResp, *Response, error)) {
	r.mockMeetingRoomDeleteMeetingRoomBuilding = f
}

// UnMockMeetingRoomDeleteMeetingRoomBuilding un-mock MeetingRoomDeleteMeetingRoomBuilding method
func (r *Mock) UnMockMeetingRoomDeleteMeetingRoomBuilding() {
	r.mockMeetingRoomDeleteMeetingRoomBuilding = nil
}

// DeleteMeetingRoomBuildingReq ...
type DeleteMeetingRoomBuildingReq struct {
	BuildingID string `json:"building_id,omitempty"` // 要删除的建筑ID
}

// DeleteMeetingRoomBuildingResp ...
type DeleteMeetingRoomBuildingResp struct {
}

// deleteMeetingRoomBuildingResp ...
type deleteMeetingRoomBuildingResp struct {
	Code int64                          `json:"code,omitempty"` // 返回码, 非 0 表示失败
	Msg  string                         `json:"msg,omitempty"`  // 返回码的描述, "success" 表示成功, 其他为错误提示信息
	Data *DeleteMeetingRoomBuildingResp `json:"data,omitempty"`
}
