// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// UpdateMeetingRoomBuilding 该接口用于编辑建筑信息, 添加楼层, 删除楼层, 编辑楼层信息。
//
// doc: https://open.feishu.cn/document/ukTMukTMukTM/uETNwYjLxUDM24SM1AjN
func (r *MeetingRoomService) UpdateMeetingRoomBuilding(ctx context.Context, request *UpdateMeetingRoomBuildingReq, options ...MethodOptionFunc) (*UpdateMeetingRoomBuildingResp, *Response, error) {
	if r.cli.mock.mockMeetingRoomUpdateMeetingRoomBuilding != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] MeetingRoom#UpdateMeetingRoomBuilding mock enable")
		return r.cli.mock.mockMeetingRoomUpdateMeetingRoomBuilding(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:                 "MeetingRoom",
		API:                   "UpdateMeetingRoomBuilding",
		Method:                "POST",
		URL:                   r.cli.openBaseURL + "/open-apis/meeting_room/building/update",
		Body:                  request,
		MethodOption:          newMethodOption(options),
		NeedTenantAccessToken: true,
	}
	resp := new(updateMeetingRoomBuildingResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockMeetingRoomUpdateMeetingRoomBuilding mock MeetingRoomUpdateMeetingRoomBuilding method
func (r *Mock) MockMeetingRoomUpdateMeetingRoomBuilding(f func(ctx context.Context, request *UpdateMeetingRoomBuildingReq, options ...MethodOptionFunc) (*UpdateMeetingRoomBuildingResp, *Response, error)) {
	r.mockMeetingRoomUpdateMeetingRoomBuilding = f
}

// UnMockMeetingRoomUpdateMeetingRoomBuilding un-mock MeetingRoomUpdateMeetingRoomBuilding method
func (r *Mock) UnMockMeetingRoomUpdateMeetingRoomBuilding() {
	r.mockMeetingRoomUpdateMeetingRoomBuilding = nil
}

// UpdateMeetingRoomBuildingReq ...
type UpdateMeetingRoomBuildingReq struct {
	BuildingID       string   `json:"building_id,omitempty"`        // 要更新的建筑ID
	Name             *string  `json:"name,omitempty"`               // 建筑名称
	Floors           []string `json:"floors,omitempty"`             // 楼层列表
	CountryID        *string  `json:"country_id,omitempty"`         // 国家/地区ID
	DistrictID       *string  `json:"district_id,omitempty"`        // 城市ID
	CustomBuildingID *string  `json:"custom_building_id,omitempty"` // 租户自定义建筑ID
}

// UpdateMeetingRoomBuildingResp ...
type UpdateMeetingRoomBuildingResp struct {
}

// updateMeetingRoomBuildingResp ...
type updateMeetingRoomBuildingResp struct {
	Code int64                          `json:"code,omitempty"` // 返回码, 非 0 表示失败
	Msg  string                         `json:"msg,omitempty"`  // 返回码的描述, "success" 表示成功, 其他为错误提示信息
	Data *UpdateMeetingRoomBuildingResp `json:"data,omitempty"`
}
