// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// CreateOKRProgressRecord 创建OKR进展记录
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/okr-v1/progress_record/create
func (r *OKRService) CreateOKRProgressRecord(ctx context.Context, request *CreateOKRProgressRecordReq, options ...MethodOptionFunc) (*CreateOKRProgressRecordResp, *Response, error) {
	if r.cli.mock.mockOKRCreateOKRProgressRecord != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] OKR#CreateOKRProgressRecord mock enable")
		return r.cli.mock.mockOKRCreateOKRProgressRecord(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:                 "OKR",
		API:                   "CreateOKRProgressRecord",
		Method:                "POST",
		URL:                   r.cli.openBaseURL + "/open-apis/okr/v1/progress_records",
		Body:                  request,
		MethodOption:          newMethodOption(options),
		NeedTenantAccessToken: true,
		NeedUserAccessToken:   true,
	}
	resp := new(createOKRProgressRecordResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockOKRCreateOKRProgressRecord mock OKRCreateOKRProgressRecord method
func (r *Mock) MockOKRCreateOKRProgressRecord(f func(ctx context.Context, request *CreateOKRProgressRecordReq, options ...MethodOptionFunc) (*CreateOKRProgressRecordResp, *Response, error)) {
	r.mockOKRCreateOKRProgressRecord = f
}

// UnMockOKRCreateOKRProgressRecord un-mock OKRCreateOKRProgressRecord method
func (r *Mock) UnMockOKRCreateOKRProgressRecord() {
	r.mockOKRCreateOKRProgressRecord = nil
}

// CreateOKRProgressRecordReq ...
type CreateOKRProgressRecordReq struct {
	SourceTitle string                             `json:"source_title,omitempty"` // 进展来源, 示例值: "周报系统"
	SourceURL   string                             `json:"source_url,omitempty"`   // 进展来源链接, 示例值: "https://www.zhoubao.com", 正则校验: `^https?://.*$`
	TargetID    string                             `json:"target_id,omitempty"`    // 目标id, 与target_type对应, 示例值: "7041430377642082323"
	TargetType  int64                              `json:"target_type,omitempty"`  // 目标类型, 示例值: 1, 可选值有: 2: okr的O, 3: okr的KR
	Content     *CreateOKRProgressRecordReqContent `json:"content,omitempty"`      // 进展详情 富文本格式
}

// CreateOKRProgressRecordReqContent ...
type CreateOKRProgressRecordReqContent struct {
	Blocks []*CreateOKRProgressRecordReqContentBlock `json:"blocks,omitempty"` // 文档结构是按行排列的, 每行内容是一个 Block
}

// CreateOKRProgressRecordReqContentBlock ...
type CreateOKRProgressRecordReqContentBlock struct {
	Type      *string                                          `json:"type,omitempty"`      // 文档元素类型, 示例值: "paragraph", 可选值有: paragraph: 文本段落, gallery: 图片
	Paragraph *CreateOKRProgressRecordReqContentBlockParagraph `json:"paragraph,omitempty"` // 文本段落
	Gallery   *CreateOKRProgressRecordReqContentBlockGallery   `json:"gallery,omitempty"`   // 图片
}

// CreateOKRProgressRecordReqContentBlockGallery ...
type CreateOKRProgressRecordReqContentBlockGallery struct {
	ImageList []*CreateOKRProgressRecordReqContentBlockGalleryImageList `json:"imageList,omitempty"` // 图片元素
}

// CreateOKRProgressRecordReqContentBlockGalleryImageList ...
type CreateOKRProgressRecordReqContentBlockGalleryImageList struct {
	FileToken *string  `json:"fileToken,omitempty"` // 图片 token, 通过上传图片接口获取, 示例值: "boxcnOj88GDkmWGm2zsTyCBqoLb"
	URL       *string  `json:"url,omitempty"`       // 图片链接, 通过上传图片接口获取, 示例值: "https://internal-api-okr.feishu-boe.cn/stream/api/downloadFile/?file_token=boxbcMTBQO9ofLjWkDuPxkxOA2c\&ticket=eyJhbGciOiJIUzUxMiIsInR5cCI6IkpXVCJ9.eyJ0YXJnZXRfaWQiOiI3MDQxNDMwMzc3NjQyMDgyMzIzIiwidGFyZ2V0X3R5cGUiOjMsImFjdGlvbiI6MiwiZmlsZV90b2tlbiI6ImJveGJjTVRCUU85b2ZMaldrRHVQeGt4T0EyYyIsInVzZXJfaWQiOiI2OTY5ODU1NTAxNzQ0ODM0MDkyIiwidGVuYW50X2lkIjoiNjg3NzUwMjY4NzYwOTQwNjk5MCIsImV4cCI6MTY0MDE1NTk2M30.yc4qV2pkGUVwSO53-N_XGgeMucjmDn9iso1Ez_8vpghFz8YdeSDf4NHQpxOHYHc8RURvwI0a5UTNKKJ9CWagTQ"
	Width     *float64 `json:"width,omitempty"`     // 图片宽, 单位px, 示例值: 458
	Height    *float64 `json:"height,omitempty"`    // 图片高, 单位px, 示例值: 372
}

// CreateOKRProgressRecordReqContentBlockParagraph ...
type CreateOKRProgressRecordReqContentBlockParagraph struct {
	Style    *CreateOKRProgressRecordReqContentBlockParagraphStyle     `json:"style,omitempty"`    // 段落样式
	Elements []*CreateOKRProgressRecordReqContentBlockParagraphElement `json:"elements,omitempty"` // 段落元素组成一个段落
}

// CreateOKRProgressRecordReqContentBlockParagraphElement ...
type CreateOKRProgressRecordReqContentBlockParagraphElement struct {
	Type     *string                                                         `json:"type,omitempty"`     // 元素类型, 示例值: "textRun", 可选值有: textRun: 文本型元素, docsLink: 文档链接型元素, person: 艾特用户型元素
	TextRun  *CreateOKRProgressRecordReqContentBlockParagraphElementTextRun  `json:"textRun,omitempty"`  // 文本
	DocsLink *CreateOKRProgressRecordReqContentBlockParagraphElementDocsLink `json:"docsLink,omitempty"` // 飞书云文档
	Person   *CreateOKRProgressRecordReqContentBlockParagraphElementPerson   `json:"person,omitempty"`   // 艾特用户
}

// CreateOKRProgressRecordReqContentBlockParagraphElementDocsLink ...
type CreateOKRProgressRecordReqContentBlockParagraphElementDocsLink struct {
	URL   *string `json:"url,omitempty"`   // 飞书云文档链接地址, 示例值: "https://xxx.feishu.cn/docx/xxxxxxxx"
	Title *string `json:"title,omitempty"` // 飞书云文档标题, 示例值: "项目说明文档"
}

// CreateOKRProgressRecordReqContentBlockParagraphElementPerson ...
type CreateOKRProgressRecordReqContentBlockParagraphElementPerson struct {
	OpenID *string `json:"openId,omitempty"` // 员工的OpenID, 示例值: "ou_3bbe8a09c20e89cce9bff989ed840674"
}

// CreateOKRProgressRecordReqContentBlockParagraphElementTextRun ...
type CreateOKRProgressRecordReqContentBlockParagraphElementTextRun struct {
	Text  *string                                                             `json:"text,omitempty"`  // 具体的文本内容, 示例值: "周报内容"
	Style *CreateOKRProgressRecordReqContentBlockParagraphElementTextRunStyle `json:"style,omitempty"` // 文本内容的样式, 支持 BIUS、颜色等
}

// CreateOKRProgressRecordReqContentBlockParagraphElementTextRunStyle ...
type CreateOKRProgressRecordReqContentBlockParagraphElementTextRunStyle struct {
	Bold          *bool                                                                        `json:"bold,omitempty"`          // 是否加粗, 示例值: true
	StrikeThrough *bool                                                                        `json:"strikeThrough,omitempty"` // 是否删除, 示例值: true
	BackColor     *CreateOKRProgressRecordReqContentBlockParagraphElementTextRunStyleBackColor `json:"backColor,omitempty"`     // 背景颜色
	TextColor     *CreateOKRProgressRecordReqContentBlockParagraphElementTextRunStyleTextColor `json:"textColor,omitempty"`     // 字体颜色
	Link          *CreateOKRProgressRecordReqContentBlockParagraphElementTextRunStyleLink      `json:"link,omitempty"`          // 链接地址
}

// CreateOKRProgressRecordReqContentBlockParagraphElementTextRunStyleBackColor ...
type CreateOKRProgressRecordReqContentBlockParagraphElementTextRunStyleBackColor struct {
	Red   *int64   `json:"red,omitempty"`   // 红 取值范围[0, 255], 示例值: 216
	Green *int64   `json:"green,omitempty"` // 绿 取值范围[0, 255], 示例值: 191
	Blue  *int64   `json:"blue,omitempty"`  // 蓝 取值范围[0, 255], 示例值: 188
	Alpha *float64 `json:"alpha,omitempty"` // 透明度 取值范围[0, 1], 示例值: 0.1
}

// CreateOKRProgressRecordReqContentBlockParagraphElementTextRunStyleLink ...
type CreateOKRProgressRecordReqContentBlockParagraphElementTextRunStyleLink struct {
	URL *string `json:"url,omitempty"` // 链接地址, 示例值: "https://www.xxxxx.com/"
}

// CreateOKRProgressRecordReqContentBlockParagraphElementTextRunStyleTextColor ...
type CreateOKRProgressRecordReqContentBlockParagraphElementTextRunStyleTextColor struct {
	Red   *int64   `json:"red,omitempty"`   // 红 取值范围[0, 255], 示例值: 216
	Green *int64   `json:"green,omitempty"` // 绿 取值范围[0, 255], 示例值: 191
	Blue  *int64   `json:"blue,omitempty"`  // 蓝 取值范围[0, 255], 示例值: 188
	Alpha *float64 `json:"alpha,omitempty"` // 透明度 取值范围[0, 1], 示例值: 0.1
}

// CreateOKRProgressRecordReqContentBlockParagraphStyle ...
type CreateOKRProgressRecordReqContentBlockParagraphStyle struct {
	Type        *string `json:"type,omitempty"`        // 列表类型, 示例值: "number", 可选值有: number: 有序列表, bullet: 无序列表, checkBox: 任务列表, checkedBox: 已完成的任务列表, indent: tab缩进
	IndentLevel *int64  `json:"indentLevel,omitempty"` // 列表的缩进级别, 支持指定一行的缩进 除代码块以外的列表都支持设置缩进, 支持 1-16 级缩进, 取值范围: [1, 16], 示例值: 1
	Number      *int64  `json:"number,omitempty"`      // 用于指定列表的行号, 仅对有序列表和代码块生效 如果为有序列表设置了缩进, 行号可能会显示为字母或者罗马数字, 示例值: 1
}

// CreateOKRProgressRecordResp ...
type CreateOKRProgressRecordResp struct {
	Data *CreateOKRProgressRecordRespData `json:"data,omitempty"` // 成功创建的进展详情
}

// CreateOKRProgressRecordRespData ...
type CreateOKRProgressRecordRespData struct {
	ProgressID string                                  `json:"progress_id,omitempty"` // OKR 进展ID
	ModifyTime string                                  `json:"modify_time,omitempty"` // 进展更新时间 毫秒
	Content    *CreateOKRProgressRecordRespDataContent `json:"content,omitempty"`     // 进展 对应的 Content 详细内容
}

// CreateOKRProgressRecordRespDataContent ...
type CreateOKRProgressRecordRespDataContent struct {
	Blocks []*CreateOKRProgressRecordRespDataContentBlock `json:"blocks,omitempty"` // 文档结构是按行排列的, 每行内容是一个 Block
}

// CreateOKRProgressRecordRespDataContentBlock ...
type CreateOKRProgressRecordRespDataContentBlock struct {
	Type      string                                                `json:"type,omitempty"`      // 文档元素类型, 可选值有: paragraph: 文本段落, gallery: 图片
	Paragraph *CreateOKRProgressRecordRespDataContentBlockParagraph `json:"paragraph,omitempty"` // 文本段落
	Gallery   *CreateOKRProgressRecordRespDataContentBlockGallery   `json:"gallery,omitempty"`   // 图片
}

// CreateOKRProgressRecordRespDataContentBlockGallery ...
type CreateOKRProgressRecordRespDataContentBlockGallery struct {
	ImageList []*CreateOKRProgressRecordRespDataContentBlockGalleryImageList `json:"imageList,omitempty"` // 图片元素
}

// CreateOKRProgressRecordRespDataContentBlockGalleryImageList ...
type CreateOKRProgressRecordRespDataContentBlockGalleryImageList struct {
	FileToken string  `json:"fileToken,omitempty"` // 图片 token, 通过上传图片接口获取
	URL       string  `json:"url,omitempty"`       // 图片链接, 通过上传图片接口获取
	Width     float64 `json:"width,omitempty"`     // 图片宽, 单位px
	Height    float64 `json:"height,omitempty"`    // 图片高, 单位px
}

// CreateOKRProgressRecordRespDataContentBlockParagraph ...
type CreateOKRProgressRecordRespDataContentBlockParagraph struct {
	Style    *CreateOKRProgressRecordRespDataContentBlockParagraphStyle     `json:"style,omitempty"`    // 段落样式
	Elements []*CreateOKRProgressRecordRespDataContentBlockParagraphElement `json:"elements,omitempty"` // 段落元素组成一个段落
}

// CreateOKRProgressRecordRespDataContentBlockParagraphElement ...
type CreateOKRProgressRecordRespDataContentBlockParagraphElement struct {
	Type     string                                                               `json:"type,omitempty"`     // 元素类型, 可选值有: textRun: 文本型元素, docsLink: 文档链接型元素, person: 艾特用户型元素
	TextRun  *CreateOKRProgressRecordRespDataContentBlockParagraphElementTextRun  `json:"textRun,omitempty"`  // 文本
	DocsLink *CreateOKRProgressRecordRespDataContentBlockParagraphElementDocsLink `json:"docsLink,omitempty"` // 飞书云文档
	Person   *CreateOKRProgressRecordRespDataContentBlockParagraphElementPerson   `json:"person,omitempty"`   // 艾特用户
}

// CreateOKRProgressRecordRespDataContentBlockParagraphElementDocsLink ...
type CreateOKRProgressRecordRespDataContentBlockParagraphElementDocsLink struct {
	URL   string `json:"url,omitempty"`   // 飞书云文档链接地址
	Title string `json:"title,omitempty"` // 飞书云文档标题
}

// CreateOKRProgressRecordRespDataContentBlockParagraphElementPerson ...
type CreateOKRProgressRecordRespDataContentBlockParagraphElementPerson struct {
	OpenID string `json:"openId,omitempty"` // 员工的OpenID
}

// CreateOKRProgressRecordRespDataContentBlockParagraphElementTextRun ...
type CreateOKRProgressRecordRespDataContentBlockParagraphElementTextRun struct {
	Text  string                                                                   `json:"text,omitempty"`  // 具体的文本内容
	Style *CreateOKRProgressRecordRespDataContentBlockParagraphElementTextRunStyle `json:"style,omitempty"` // 文本内容的样式, 支持 BIUS、颜色等
}

// CreateOKRProgressRecordRespDataContentBlockParagraphElementTextRunStyle ...
type CreateOKRProgressRecordRespDataContentBlockParagraphElementTextRunStyle struct {
	Bold          bool                                                                              `json:"bold,omitempty"`          // 是否加粗
	StrikeThrough bool                                                                              `json:"strikeThrough,omitempty"` // 是否删除
	BackColor     *CreateOKRProgressRecordRespDataContentBlockParagraphElementTextRunStyleBackColor `json:"backColor,omitempty"`     // 背景颜色
	TextColor     *CreateOKRProgressRecordRespDataContentBlockParagraphElementTextRunStyleTextColor `json:"textColor,omitempty"`     // 字体颜色
	Link          *CreateOKRProgressRecordRespDataContentBlockParagraphElementTextRunStyleLink      `json:"link,omitempty"`          // 链接地址
}

// CreateOKRProgressRecordRespDataContentBlockParagraphElementTextRunStyleBackColor ...
type CreateOKRProgressRecordRespDataContentBlockParagraphElementTextRunStyleBackColor struct {
	Red   int64   `json:"red,omitempty"`   // 红 取值范围[0, 255]
	Green int64   `json:"green,omitempty"` // 绿 取值范围[0, 255]
	Blue  int64   `json:"blue,omitempty"`  // 蓝 取值范围[0, 255]
	Alpha float64 `json:"alpha,omitempty"` // 透明度 取值范围[0, 1]
}

// CreateOKRProgressRecordRespDataContentBlockParagraphElementTextRunStyleLink ...
type CreateOKRProgressRecordRespDataContentBlockParagraphElementTextRunStyleLink struct {
	URL string `json:"url,omitempty"` // 链接地址
}

// CreateOKRProgressRecordRespDataContentBlockParagraphElementTextRunStyleTextColor ...
type CreateOKRProgressRecordRespDataContentBlockParagraphElementTextRunStyleTextColor struct {
	Red   int64   `json:"red,omitempty"`   // 红 取值范围[0, 255]
	Green int64   `json:"green,omitempty"` // 绿 取值范围[0, 255]
	Blue  int64   `json:"blue,omitempty"`  // 蓝 取值范围[0, 255]
	Alpha float64 `json:"alpha,omitempty"` // 透明度 取值范围[0, 1]
}

// CreateOKRProgressRecordRespDataContentBlockParagraphStyle ...
type CreateOKRProgressRecordRespDataContentBlockParagraphStyle struct {
	Type        string `json:"type,omitempty"`        // 列表类型, 可选值有: number: 有序列表, bullet: 无序列表, checkBox: 任务列表, checkedBox: 已完成的任务列表, indent: tab缩进
	IndentLevel int64  `json:"indentLevel,omitempty"` // 列表的缩进级别, 支持指定一行的缩进 除代码块以外的列表都支持设置缩进, 支持 1-16 级缩进, 取值范围: [1, 16]
	Number      int64  `json:"number,omitempty"`      // 用于指定列表的行号, 仅对有序列表和代码块生效 如果为有序列表设置了缩进, 行号可能会显示为字母或者罗马数字
}

// createOKRProgressRecordResp ...
type createOKRProgressRecordResp struct {
	Code int64                        `json:"code,omitempty"` // 错误码, 非 0 表示失败
	Msg  string                       `json:"msg,omitempty"`  // 错误描述
	Data *CreateOKRProgressRecordResp `json:"data,omitempty"`
}
