// Code generated by lark_sdk_gen. DO NOT EDIT.
/**
 * Copyright 2022 chyroc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package lark

import (
	"context"
)

// EndVCMeeting 结束一个进行中的会议
//
// 会议正在进行中, 且操作者须具有相应的权限（如果操作者为用户, 必须是会中当前主持人）
//
// doc: https://open.feishu.cn/document/uAjLw4CM/ukTMukTMukTM/reference/vc-v1/meeting/end
func (r *VCService) EndVCMeeting(ctx context.Context, request *EndVCMeetingReq, options ...MethodOptionFunc) (*EndVCMeetingResp, *Response, error) {
	if r.cli.mock.mockVCEndVCMeeting != nil {
		r.cli.log(ctx, LogLevelDebug, "[lark] VC#EndVCMeeting mock enable")
		return r.cli.mock.mockVCEndVCMeeting(ctx, request, options...)
	}

	req := &RawRequestReq{
		Scope:               "VC",
		API:                 "EndVCMeeting",
		Method:              "PATCH",
		URL:                 r.cli.openBaseURL + "/open-apis/vc/v1/meetings/:meeting_id/end",
		Body:                request,
		MethodOption:        newMethodOption(options),
		NeedUserAccessToken: true,
	}
	resp := new(endVCMeetingResp)

	response, err := r.cli.RawRequest(ctx, req, resp)
	return resp.Data, response, err
}

// MockVCEndVCMeeting mock VCEndVCMeeting method
func (r *Mock) MockVCEndVCMeeting(f func(ctx context.Context, request *EndVCMeetingReq, options ...MethodOptionFunc) (*EndVCMeetingResp, *Response, error)) {
	r.mockVCEndVCMeeting = f
}

// UnMockVCEndVCMeeting un-mock VCEndVCMeeting method
func (r *Mock) UnMockVCEndVCMeeting() {
	r.mockVCEndVCMeeting = nil
}

// EndVCMeetingReq ...
type EndVCMeetingReq struct {
	MeetingID string `path:"meeting_id" json:"-"` // 会议ID（视频会议的唯一标识, 视频会议开始后才会产生）, 示例值: "6911188411932033028"
}

// EndVCMeetingResp ...
type EndVCMeetingResp struct {
}

// endVCMeetingResp ...
type endVCMeetingResp struct {
	Code int64             `json:"code,omitempty"` // 错误码, 非 0 表示失败
	Msg  string            `json:"msg,omitempty"`  // 错误描述
	Data *EndVCMeetingResp `json:"data,omitempty"`
}
